
/******************************************************************************
ļ  :
  :
  :
޸  :

******************************************************************************/

#include "Drv_Dht12.h"

#define I2cDelay()  DelayUs(20)

#define SclHi()     GPIO_SetBits(Dht12_SCL_GPIO_PORT, Dht12_SCL_PIN)
#define SclLo()     GPIO_ResetBits(Dht12_SCL_GPIO_PORT, Dht12_SCL_PIN)
#define SclRead()   GPIO_ReadInputDataBit(Dht12_SCL_GPIO_PORT, Dht12_SCL_PIN)

#define SdaHi()     GPIO_SetBits(Dht12_SDA_GPIO_PORT, Dht12_SDA_PIN)
#define SdaLo()     GPIO_ResetBits(Dht12_SDA_GPIO_PORT, Dht12_SDA_PIN)
#define SdaRead()   GPIO_ReadInputDataBit(Dht12_SDA_GPIO_PORT, Dht12_SDA_PIN)

u8 Dht12Error = 0;
StructDht12Data Dht12Data =
{
  .ValidFlag = 0,
  .Dht12Humity = 5000,
  .Dht12Temp = 2500,
};

/******************************************************************************
  : DelayUs
  : ΢뼰ʱ
  : Us - Ҫʱ΢
  : 
******************************************************************************/
static void DelayUs(u32 Us)
{
  u32 i;

  while(Us)
  {
    for(i=0;i<31;i++)
    {
    }
    Us--;
  }
}

/******************************************************************************
  : SetSclOut
  : SCLźΪ©
  : 
  : 
******************************************************************************/
static void SetSclOut(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Pin = Dht12_SCL_PIN;
  GPIO_Init(Dht12_SCL_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : SetSclIn
  : SCLźΪ
  : 
  : 
******************************************************************************/
static void SetSclIn(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Pin = Dht12_SCL_PIN;
  GPIO_Init(Dht12_SCL_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : SetSclOutExt
  : SCLźΪ
  : 
  : 
******************************************************************************/
static void SetSclOutExt(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Pin = Dht12_SCL_PIN;
  GPIO_Init(Dht12_SCL_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : SetSdaOut
  : SDAźΪ©
  : 
  : 
******************************************************************************/
static void SetSdaOut(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Pin = Dht12_SDA_PIN;
  GPIO_Init(Dht12_SDA_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : SetSdaIn
  : SDAźΪ
  : 
  : 
******************************************************************************/
static void SetSdaIn(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Pin = Dht12_SDA_PIN;
  GPIO_Init(Dht12_SDA_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : SetSdaOutExt
  : SDAźΪ
  : 
  : 
******************************************************************************/
static void SetSdaOutExt(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Pin = Dht12_SDA_PIN;
  GPIO_Init(Dht12_SDA_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : I2cStart
  : I2C߿ʼź
  : 
  : TRUE - ʼ
        FALSE - ʼ
******************************************************************************/
static u8 I2cStart(void)
{
  u8 i;

  SclHi();
  SdaHi();
  I2cDelay();
  SetSclIn();
  SetSdaIn();
  if(0 == SdaRead() || (0 == SclRead()))
  {//
    SetSclOutExt();
    for(i=0; i<10; i++)//9clk
    {
      SclHi();
      I2cDelay();
      I2cDelay();
      SclLo();
      I2cDelay();
      I2cDelay();
    }
    SetSdaOutExt();//
    SdaLo();
    I2cDelay();
    SclHi();
    I2cDelay();
    SdaHi();

    SetSclIn();
    SetSdaIn();
    I2cDelay();
    if(0 == SdaRead() || (0 == SclRead()))
    {
      SetSclOut();
      SetSdaOut();
      return FALSE;
    }
  }
  /*Ϊ*/
  SetSclOutExt();
  SetSdaOutExt();
  I2cDelay();
  SdaLo();
  I2cDelay();
  SclLo();
  I2cDelay();
  return TRUE;
}

/******************************************************************************
  : I2cReStart
  : I2C¿ʼ
  : 
  : 
******************************************************************************/
static void I2cReStart(void)
{
  SdaHi();
  SclHi();
  I2cDelay();
  SdaLo();
  I2cDelay();
  SclLo();
  I2cDelay();
}

/******************************************************************************
  : I2cStart
  : I2C߽ź
  : 
  : 
******************************************************************************/
static void I2cStop(void)
{
  SdaLo();   //PA2(SDA)=00v
  I2cDelay();
  SclHi();    //PA1(SCL)=13.3V
  I2cDelay();
  SdaHi();    //PA2(SDA)=13.3V
  I2cDelay();
  /*Ϊ©*/
  SetSclOut();
  SetSdaOut();
}

/******************************************************************************
  : I2cSendByte
  : I2C߷һֽ
  : Data - ͵ֽ
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
static u8 I2cSendByte(u8 Data)
{
  u8 i;
  u8 Bit;
  u8 Rtn;
  u8 TimeOut = 100;
  Bit = 0x80;
  for(i=0; i<8; i++)
  {
    if(Data & Bit)
      SdaHi();//SDAŷ1
    else
      SdaLo();//SDAŷ0
    I2cDelay();
    SclHi();    //PA1(SCL)=13.3V
    I2cDelay();
    I2cDelay();
    SclLo();   //PA1(SCL)=00v
    Bit = Bit >> 1;
    I2cDelay();
  }

  SdaHi();
  SetSdaIn();
  I2cDelay();
  SclHi();
  I2cDelay();
  if(SdaRead())
    Rtn = FALSE;
  else
    Rtn = TRUE;
  I2cDelay();
  SclLo();
  I2cDelay();
  SetSdaOutExt();
  if(Data == 0)
    TimeOut++;
  return Rtn;
}

/******************************************************************************
  : I2cReadByte
  : I2C߶һֽ
  : Ack - 0 Ӧ 1 Ӧ
  : ض
******************************************************************************/
static u8 I2cReadByte(u8 Ack)
{
  u8 i;
  u8 Data;

  Data = 0;
  SetSdaIn();
  for(i=0; i<8; i++)
  {
    Data = Data << 1;
    I2cDelay();
    SclHi();    //PA1(SCL)=13.3V
    I2cDelay();
    if(SdaRead())
      Data |= 0x01;
    I2cDelay();
    SclLo();   //PA1(SCL)=00v
    I2cDelay();
  }
  SetSdaOutExt();

  if(Ack)
    SdaHi();
  else
    SdaLo();
  I2cDelay();
  SclHi();
  I2cDelay();
  I2cDelay();
  SclLo();
  I2cDelay();
  return Data;
}

osMutexId Dht12Mutex = NULL;

/******************************************************************************
  : Dht12Init
  : Dht12ӿڳʼ
  : 
  : TRUE - ʼ
        FALSE - ʼ
******************************************************************************/
u8 Dht12Init(void)
{
  u8 i;

  Dht12Mutex = NULL;

  RCC_AHB1PeriphClockCmd(Dht12_SCL_GPIO_CLK, ENABLE);
  RCC_AHB1PeriphClockCmd(Dht12_SDA_GPIO_CLK, ENABLE);
  SclHi();
  SdaHi();
  SetSdaOut();
  SetSclOut();

  I2cDelay();
  SetSclIn();
  SetSdaIn();
  if(0 == SdaRead() || (0 == SclRead()))
  {//
    SetSclOutExt();
    for(i=0; i<10; i++)//9clk
    {
      SclHi();
      I2cDelay();
      I2cDelay();
      SclLo();
      I2cDelay();
      I2cDelay();
    }
    SetSdaOutExt();//
    SdaLo();
    I2cDelay();
    SclHi();
    I2cDelay();
    SdaHi();

    SetSclIn();
    SetSdaIn();
    I2cDelay();
    if(0 == SdaRead() || (0 == SclRead()))
    {
//      SclHi();
//      SdaHi();
      SetSclOut();
      SetSdaOut();
      return FALSE;
    }
  }

//  SclHi();
//  SdaHi();
  SetSclOut();
  SetSdaOut();

  osMutexDef(Dht12Mutex);
  Dht12Mutex = osMutexCreate(osMutex(Dht12Mutex));

  return TRUE;
}

/******************************************************************************
  : I2cSendByte
  : 24C512
  : Addr - ʼַ
        pData - ݵָ
        Len - Ҫݳ
  : ο EnumDht12Error
******************************************************************************/
EnumDht12Error Dht12ReadData(u8 *pDht12)
{
  EnumDht12Error Err;
  u16 i;

  if(NULL == Dht12Mutex)
    return eDht12Err_Error;

  if(NULL == pDht12)
    return eDht12Err_DataPiont;

  if(osOK != osMutexWait(Dht12Mutex, 5000))//5
    return eDht12Err_Error;

  if(FALSE == I2cStart())
  {
    Dht12Error = 1;
    Err = eDht12Err_BusErr;
    goto __Dht12ReadReturn__;
  }

  Err = eDht12Err_Sucess;
  if(FALSE == I2cSendByte(Dht12_SlaveAddr))
  {
    Dht12Error = 2;
    Err = eDht12Err_WriteCmd;
    goto __Dht12ReadReturn__;
  }
 // if(FALSE == I2cSendByte((u8)(eDht12_Humity_H_Addr)))
//  {
//    Err = eDht12Err_RegAddr;
 //   goto __Dht12ReadReturn__;
//  }
 DelayUs(810);

  I2cStop();



  I2cReStart();
  if(FALSE == I2cSendByte(Dht12_SlaveAddr))
  {
    Err = eDht12Err_ReadCmd;
    goto __Dht12ReadReturn__;
  }
  if(FALSE == I2cSendByte(0x03))
  {
    Err = eDht12Err_ReadCmd;
    goto __Dht12ReadReturn__;
  }
  if(FALSE == I2cSendByte(0x00))
	{
	  Err = eDht12Err_ReadCmd;
	  goto __Dht12ReadReturn__;
	}
  if(FALSE == I2cSendByte(0x04))
	{
	  Err = eDht12Err_ReadCmd;
	  goto __Dht12ReadReturn__;
	}
  I2cStop();
  DelayUs(2000);

  I2cReStart();
  if(FALSE == I2cSendByte(Dht12_SlaveAddr|0x01))
  {
    Err = eDht12Err_ReadCmd;
    goto __Dht12ReadReturn__;
  }


  for(i=0; i< (7); i++)
  {
    pDht12[i] = I2cReadByte(0);
  }

  pDht12[i] = I2cReadByte(1);

__Dht12ReadReturn__:
  I2cStop();
  osMutexRelease(Dht12Mutex);
  if(eDht12Err_Sucess == Err)
    Dht12Error = 0;
  return Err;
}
u16 crc16(u8 *ptr ,u8 len)
{
 u16 crc = 0xFFFF;
 u8 i;
 while(len--)
 {
  crc^=*ptr++;
  for(i = 0;i<8;i++)
  	{
  	 if(crc&0x01)
  	 {
  	 	crc>>=1;
		crc^=0xA001;
  	 }
	 else
	 	crc>>=1;
  	}
 }
 return crc;
}
#define HumiValueNum 1
u8 Dht12_GetHumiAndTemp(void)
{
  static s16 HumiValueBuff[eDht12_Num][HumiValueNum];
  static u8 num = 0;

  s32 HumiValueSum[eDht12_Num];
  u8 Dht12DataBuf[8];
  u8 DataChkSum;
  u8 i;
  if(eDht12Err_Sucess == Dht12ReadData((&Dht12DataBuf[0])))
  {
    DataChkSum = 0;
    //for(i = 0; i < (8 - 1); i++)
   // {
   //  DataChkSum += Dht12DataBuf[i];
  //  }
    DataChkSum = crc16(&Dht12DataBuf[0],6);
    if(DataChkSum == (Dht12DataBuf[6]))
    {
      if(HumiValueNum <= num)
      {
        num = 0;
        Dht12Data.ValidFlag = 1;
      }
      HumiValueBuff[eDht12_HumityNum][num] = (Dht12DataBuf[2]*256+Dht12DataBuf[3])*10;
	  if((Dht12DataBuf[4]&0x08))
      HumiValueBuff[eDht12_TempNum][num] = (-((u16)((Dht12DataBuf[4]&0x07)*256 + Dht12DataBuf[5])*10));
	  else
	  	HumiValueBuff[eDht12_TempNum][num] =((Dht12DataBuf[4]&0x07)*256 + Dht12DataBuf[5])*10;

      num ++;
      HumiValueSum[eDht12_HumityNum] = 0;
      HumiValueSum[eDht12_TempNum] = 0;
      for(i=0; i<HumiValueNum; i++)
      {
        HumiValueSum[eDht12_HumityNum]+= HumiValueBuff[eDht12_HumityNum][i];
        HumiValueSum[eDht12_TempNum]+= HumiValueBuff[eDht12_TempNum][i];
      }

      Dht12Data.Dht12Humity = (u16)(HumiValueSum[eDht12_HumityNum]/HumiValueNum);
      Dht12Data.Dht12Temp = (s16)(HumiValueSum[eDht12_TempNum]/HumiValueNum);
      return TRUE;
    }
  }
  if(Dht12Data.ValidFlag == 0)
  Dht12Data.ValidFlag = 0;
  return FALSE;
}

u16 Dht12_GetHumi(void)
{
  return Dht12Data.Dht12Humity;
}

s16 Dht12_GetTemp(void)
{
 return Adc_Get_B_PTemp();// Dht12Data.Dht12Temp/100;
}
