
/******************************************************************************
ļ  : Drv_Elock.c
  : 
  :
޸  : 2014-09-26      

******************************************************************************/

#include "Drv_Elock.h"

static EnumSwitchStatus ElockSet_A;
static EnumSwitchStatus ElockSet_B;


/******************************************************************************
  : ElockSetStatus_A
  : ýӴ״̬
  : Status - eSwSta_On
                 eSwSta_OffϿ
  : 
******************************************************************************/
void ElockSetStatus_A(EnumSwitchStatus Status)
{
  if(eSwSta_Off == Status)
    GPIO_ResetBits(Elock_A_PORT, Elock_A_PIN);
  else
    GPIO_SetBits(Elock_A_PORT, Elock_A_PIN);
  ElockSet_A = Status;
}

/******************************************************************************
  : ElockSetStatus_B
  : ýӴ״̬
  : Status - eSwSta_On
                 eSwSta_OffϿ
  : 
******************************************************************************/
void ElockSetStatus_B(EnumSwitchStatus Status)
{
  if(eSwSta_Off == Status)
    GPIO_ResetBits(Elock_B_PORT, Elock_B_PIN);
  else
    GPIO_SetBits(Elock_B_PORT, Elock_B_PIN);
  ElockSet_B = Status;
}

/******************************************************************************
  : ElockInit
  : Ccʼ
  : 
  : 
******************************************************************************/
void ElockInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  ElockSet_A = eSwSta_Off;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  GPIO_InitStructure.GPIO_Pin = Elock_A_PIN;
  RCC_APB2PeriphClockCmd(Elock_A_RCC, ENABLE);
  GPIO_Init(Elock_A_PORT, &GPIO_InitStructure);
  GPIO_ResetBits(Elock_A_PORT, Elock_A_PIN);

  ElockSet_B = eSwSta_Off;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  GPIO_InitStructure.GPIO_Pin = Elock_B_PIN;
  RCC_APB2PeriphClockCmd(Elock_B_RCC, ENABLE);
  GPIO_Init(Elock_B_PORT, &GPIO_InitStructure);
  GPIO_ResetBits(Elock_B_PORT, Elock_B_PIN);
}

/******************************************************************************
  : ElockGetStatus_A
  : Elock״̬ȡ
  : 
  : eSwSta_On     eSwSta_Off Ͽ
******************************************************************************/
EnumSwitchStatus ElockGetStatus_A(void)
{
  return ElockSet_A;
}

/******************************************************************************
  : ElockGetStatus_B
  : Elock״̬ȡ
  : 
  : eSwSta_On     eSwSta_Off Ͽ
******************************************************************************/
EnumSwitchStatus ElockGetStatus_B(void)
{
  return ElockSet_B;
}



/******************************************************************************
  : ElockSetStatus
  : ýӴ״̬
  : Status - eSwSta_On
                 eSwSta_OffϿ
  : 
******************************************************************************/
void ElockSetStatus(EnumSwitchStatus Status)
{
  if(eSwSta_Off == Status)
    GPIO_ResetBits(Elock_A_PORT, Elock_A_PIN);
  else
    GPIO_SetBits(Elock_A_PORT, Elock_A_PIN);
  ElockSet_A = Status;
}


/******************************************************************************
  : ElockGetStatus
  : Elock״̬ȡ
  : 
  : eSwSta_On     eSwSta_Off Ͽ
******************************************************************************/
EnumSwitchStatus ElockGetStatus(void)
{
  return ElockSet_A;
}


