/******************************************************************************
ļ  : FTP_Ugrade.c
  : Drv_W5500Ļ---FTP
  : Willon Gong
޸  : 2018-03-19  Willon Gong    

******************************************************************************/

#include "FTP_Upgrade.h"
#include "Drv_W5500.h"
#include "Memory.h"


#define		SOCKET_CMD          0
//#define		SOCKET_DAT          1
#define 	FtpClientCmdPort 		12000				//ͻ˵˿
#define 	FtpClientDatPort 		12001				//ͻ˵ݶ˿
#define   FtpRcvLength       1024

StruntFtpUpgradeInfo FtpInfo = {
#if 0
  "192.168.1.12",
  "21",
  "Gong",
  "1234"
#else
  #if 0
  "218.17.56.50",
  "2121",
  "ftpuser",
  "bsbnet"
  #else
  "47.106.214.72",
  "2121",
  "bsb",
  "DC_1.bin",
  "Administrator",
  "Gwl4440098"
  #endif
#endif
};

extern osMessageQId CableNetRecvQ;
extern u8 CableNetStatus;
extern osMutexId W5500Mutex;
extern osThreadId InternetHandle;
extern void CableNetInit(void);
static u32 LastRecvTick = 0;
static u8  Ftp_flag = 0;

void FtpStart(void)
{
  Ftp_flag = 1;
}

u8 ReadFtpState(void)
{
  return Ftp_flag;
}

u8 assicToU16(u8* pdata, u16* tport ,u8 len)
{
    int i;
    u16 temp = 0;
    temp = 0;
    for(i = 0; i < len; i++)
    {
      if( (pdata[i] <= 0x39) && (pdata[i] >= 0x30) )
      {

          temp = temp*10 + pdata[i] - 0x30;
      }
      else
      {
      	  break;
      }
    }
	*tport = temp;
    return 1;
}
u8 assicKeyToVal(u8* pdata, u8* tip, u8 len)
{
    int i = 0;
    u8 ip[4];u8 ip_i = 0;
    u16 temp = 0;

    temp = 0;
    ip_i = 0;
    for(i = 0; i < 18; i++)//18ַ
    {
      if( (pdata[i] >= 0x30) && (pdata[i] <= 0x39) )//ȡ0-9ֵ
      {
        temp = temp*10 + (pdata[i]-0x30);
      }
      else if( pdata[i] == '.' )//"."Ϊָ
      {
          if(temp >= 256) return 0;
          ip[ip_i++] = temp;
          temp = 0;
      }
      else
      {
        if(temp >= 256) return 0;
        ip[ip_i++] = temp;
          break;
      }
    }
    if(ip_i < len)
      return 0;
    else
    {
      for(i = 0; i < len; i++)
      {
        tip[i] = ip[i];
      }
      return 1;
    }
}

//ȡFTPݶ˿
void 	GetFtpDatPort(u8 *pdat,u8 dlen,u8 *dip, u16 *dport)
{
		u8 i,step=0;

		for(i=0;i<dlen;i++){
			if(*pdat++=='(')
			{
				dip[step]=atoi((const char *)pdat);
				step++;
				continue;
			}

			if(*pdat==','){
				pdat++;
				switch(step){
					case 1:
					case 2:
					case 3:
						dip[step]=atoi((const char *)pdat);
						step++;
						break;
					case 4:
						(*dport) = atoi((const char *)pdat)*256;
						step++;
						break;
					case 5:
						(*dport) += atoi((const char *)pdat);
						step++;
						break;
					default:
						break;
				}
				continue;
			}

			if(*pdat==')')
				break;
		}
}

u8 Buff[FtpRcvLength];
u8 FtpSend[256];
u8 SOCKET_DAT = 1;
void FTP_Communicate(void)
{
  u16 RecvLen;
//  char name[20] = "Gong";
//  char pswd[20] = "1234";
//  memcpy((u8 *)FtpInfo.UserName,(u8 *)name,sizeof(name));
//  memcpy((u8 *)FtpInfo.UserPswd,(u8 *)pswd,sizeof(pswd));

	char *pUser,*pPswd;
	static u32 ftprcvlen,ftpsndlen,ftp_step,RetCmd,file_size,FSN,MaxNo;

  u8 Dip[4] = {0};//{192,168,1,12};
  u16 Dport = 0;

//char ftp_path[80] = "\Putian/AC/63A_D";
//  char ftp_path[80] = "bsb/dc";
//char ftp_path[80] = "eepilefile";
//  ftp_path[0] = 0x2f;
//  char ftp_filename[80]= "DcPillar.bin";
//char ftp_filename[80] = "ACS32B_201W_Bsb_V1.09_Res20180530.bin";
//  u8 SocketIr = 0;
  u8 LinkPin = 0;
//  u32 ConnectTick = 0;
  u32 ResetNetTick = 0;
  u8 AckTime = 0;

  u8 CmdReady = 0;
  u8 DataReady = 0;

  assicKeyToVal(FtpInfo.UpgradeSvIp, Dip, 4);

  RecvLen = getSn_RX_RSR(SOCKET_CMD);/*lenΪѽݵĳ*/
  if(RecvLen > 0)
  {
    LastRecvTick = GetSystemTick();
    if(RecvLen > sizeof(Buff))
      RecvLen = sizeof(Buff);
    recv(SOCKET_CMD, Buff, RecvLen);/*Server*/
		RetCmd = atoi((const char *)&Buff[0]);
    switch(RetCmd)
    {
        case 220:
          pUser = (char *)FtpInfo.UserName;
          ftpsndlen = sprintf((char *)FtpSend,"USER %s\r\n",pUser);
          send(SOCKET_CMD, (unsigned char *)&FtpSend[0],ftpsndlen);
          break;

        case 331: //ANDY  2016.1.1
          pPswd = (char *)FtpInfo.UserPswd;
          ftpsndlen = sprintf((char *)FtpSend,"PASS %s\r\n",pPswd);
          send(SOCKET_CMD, (unsigned char *)&FtpSend[0],ftpsndlen);
          break;

        case 230:
          ftpsndlen = sizeof("PWD\r\n");
          memcpy((unsigned char *)&FtpSend[0],"PWD\r\n",ftpsndlen);
          send(SOCKET_CMD, (unsigned char *)&FtpSend[0],ftpsndlen);
          break;

        case 257:
					ftpsndlen = sprintf((char *)FtpSend,"CWD %s\r\n",FtpInfo.FilePath);
          send(SOCKET_CMD, (unsigned char *)&FtpSend[0],ftpsndlen);
          break;

        case 250:
          ftpsndlen = sprintf((char *)FtpSend,"SIZE %s\r\n",FtpInfo.FileName);
          send(SOCKET_CMD, (unsigned char *)&FtpSend[0],ftpsndlen);
          break;

        case 550:
          //ʧ
          NVIC_SystemReset();
          while(1);
          break;

        case 213:
          file_size = atoi((const char *)&Buff[4]);
          ftpsndlen = sizeof("PASV\r\n");
          memcpy((unsigned char *)&FtpSend[0],"PASV\r\n",ftpsndlen);
          send(SOCKET_CMD, (unsigned char *)&FtpSend[0],ftpsndlen);
          break;

        case 227:
          GetFtpDatPort((unsigned char *)&Buff[4],strlen((char *)Buff)-4, Dip, &Dport);
          assicKeyToVal(FtpInfo.UpgradeSvIp, Dip, 4);
      //    socket(SOCKET_DAT, Sn_MR_TCP, FtpClientDatPort, Sn_MR_ND);
          CmdReady = 1;
          break;

        default:
          break;
    }


    if(CmdReady)
    {
        close(SOCKET_DAT);
        for(;;)
        {
              osDelay(50);
              LinkPin = wizphy_getphylink();
              if(0 == LinkPin)
              {
                CableNetStatus = SOCK_CLOSED;
              }
              else
                CableNetStatus = getSn_SR(SOCKET_DAT);
              /*ȡsocket״̬*/

              switch(CableNetStatus)
              {
                case SOCK_CLOSED:/*socketڹر״̬*/
                  if(0 == ResetNetTick)
                    ResetNetTick = GetSystemTick();
                  else if((GetSystemTick() - ResetNetTick) > 8000)
                  {
                    //CableNetInit();
                    SOCKET_DAT++;
                    if(SOCKET_DAT > 2)
                      SOCKET_DAT = 1;
                    UserParam.FtpDataChn = SOCKET_DAT;
                    SaveUserParam((u8*)&UserParam, sizeof(UserParam));
                    osDelay(100);
                    NVIC_SystemReset();
                    osDelay(1000);
                    while(1);
//                    ResetNetTick = GetSystemTick();
                  }
                  socket(SOCKET_DAT, Sn_MR_TCP, FtpClientDatPort, Sn_MR_ND);
                  break;

                case SOCK_INIT:/*socketڳʼ״̬*/
                  LastRecvTick = 0;
              //    SOCKET_DAT++;
                //  if(SOCKET_DAT > 7)
                  //  SOCKET_DAT = 1;
                  connect(SOCKET_DAT,Dip,Dport); /*socketӷ*/
                  AckTime = 0;
                  break;

                case SOCK_ESTABLISHED:/*socketӽ״̬*/
                  DataReady = 1;
                  if(0 == LastRecvTick)
                    LastRecvTick = GetSystemTick();
                  if(getSn_IR(SOCKET_DAT) & Sn_IR_CON)
                    setSn_IR(SOCKET_DAT, Sn_IR_CON); /*жϱ־λ*/
                  if((GetSystemTick() - LastRecvTick) > (2*60*1000))
                    close(SOCKET_DAT);
                  break;

                case SOCK_CLOSE_WAIT:/*socketڵȴر״̬*/
                  close(SOCKET_DAT);
                  break;
                case SOCK_SYNSENT:
                  if(AckTime > 8)
                  {
                    AckTime = 0;
                    close(SOCKET_DAT);
          //          SOCKET_DAT++;
          //          if(SOCKET_DAT > 2)
          //            SOCKET_DAT = 1;
                  }
                  else
                    AckTime++;
                  break;

                default:
                  break;
              }
              if(DataReady)
                break;
              osDelay(300);
        }
    }
    if(DataReady)
    {
        if(ftp_step==0)
        {
          ftp_step++;
          memset((unsigned char *)&FtpSend[0],0,sizeof(FtpSend));
          ftpsndlen = sprintf((char *)FtpSend,"RETR %s\r\n",FtpInfo.FileName);
          send(SOCKET_CMD, (unsigned char *)&FtpSend[0],ftpsndlen);
        }
        do{
        ftprcvlen = getSn_RX_RSR(SOCKET_CMD);/*lenΪѽݵĳ*/
        osDelay(15);
      //  DelayUs(10);
        }while(ftprcvlen==0);
        recv(SOCKET_CMD, Buff, ftprcvlen);
        if(ftprcvlen>0)
        {
          RetCmd = atoi((const char *)&Buff[0]);
          switch(RetCmd){
            case 125:
            case 150:
              ftp_step++;           //??????
              break;
            case 200:
            case 226:
              ftp_step++;           //??????
              break;
            default:
              break;
          }
        }
        if(getSn_IR(SOCKET_DAT) & Sn_IR_CON)
          setSn_IR(SOCKET_DAT, Sn_IR_CON); /*жϱ־λ*/

        MaxNo=file_size/FtpRcvLength;
        if(file_size%FtpRcvLength!=0)
          MaxNo++;
        FSN = 0;
        AckTime = 0;
        while(AckTime < 200)
        {
          osDelay(20);
          ftprcvlen = getSn_RX_RSR(SOCKET_DAT);/*lenΪѽݵĳ*/
          if(ftprcvlen==0)
            continue;
          if( (FSN != (MaxNo-1) ) && (ftprcvlen < FtpRcvLength) )
            continue;
          else if(FSN == (MaxNo-1))
            osDelay(200);
          if(ftprcvlen > FtpRcvLength)  ftprcvlen = FtpRcvLength;
          recv(SOCKET_DAT, Buff, ftprcvlen);

          AckTime = 0;
          if(FSN!=(MaxNo-1))
          {
            if(ftprcvlen!=FtpRcvLength)
            {
              //ʧ
              NVIC_SystemReset();
              while(1);
            }
            else{
              CopyCode(BakStartAddr+FtpRcvLength*FSN,(u32)Buff, FtpRcvLength);
              FSN++;
            }
          }
          else
          {
            if(ftprcvlen<FtpRcvLength)
              memset((unsigned int *)&Buff[ftprcvlen],0xff,FtpRcvLength-ftprcvlen);
            CopyCode(BakStartAddr+FtpRcvLength*FSN,(u32)Buff, FtpRcvLength);
            FSN++;
            Ftp_flag = 0;
            //ɹ
            UpdateFlagSet(0x414E4747);
            osDelay(500);
            NVIC_SystemReset();
            while(1);
          }
        }

        if((GetSystemTick() - LastRecvTick) > (2*60*1000))
          close(SOCKET_DAT);
    }
  }

}

/******************************************************************************
  : Thd_W5500_FTP
  : FTP
  : argument - ̴߳
  : 
******************************************************************************/
void FTP_Run(void)
{
  u8 SocketIr = 0;
  u8 LinkPin = 0;
  u32 ConnectTick = 0;
  u32 ResetNetTick = 0;

  u8  Ip[4] = {0};//{192, 168, 1, 12};
  u16 Port = 0;//21;

  close(SocketCommu);
  assicKeyToVal(FtpInfo.UpgradeSvIp, Ip, 4);
  assicToU16(FtpInfo.UpgradePort, &Port,5);
  osThreadSuspend(InternetHandle);

  osDelay(1000);
  socket(SOCKET_CMD, Sn_MR_TCP, FtpClientCmdPort, Sn_MR_ND);

  for(;;)
  {
    osDelay(50);
    LinkPin = wizphy_getphylink();
    if(0 == LinkPin)
    {
      ResetNetTick = 0;
      CableNetStatus = SOCK_CLOSED;
      //continue;
    }
    else
      CableNetStatus = getSn_SR(SOCKET_CMD);
    /*ȡsocket״̬*/

    switch(CableNetStatus)
    {
      case SOCK_CLOSED:/*socketڹر״̬*/
        if(0 == ResetNetTick)
          ResetNetTick = GetSystemTick();
        else if((GetSystemTick() - ResetNetTick) > 300000)
        {
          CableNetInit();
          osDelay(1000);
          ResetNetTick = GetSystemTick();
        }
        socket(SOCKET_CMD, Sn_MR_TCP, FtpClientCmdPort, Sn_MR_ND);
        break;

      case SOCK_INIT:/*socketڳʼ״̬*/
        LastRecvTick = 0;
        connect(SOCKET_CMD,Ip,Port); /*socketӷ*/
//        connect(SOCKET_CMD,ServerAddr.Ip,ServerAddr.Port); /*socketӷ*/
        ConnectTick = GetSystemTick();
        while(1)
        {
          SocketIr = getSn_IR(SOCKET_CMD);

          if(SocketIr & Sn_IR_CON)
          {
            setSn_IR(SOCKET_CMD, Sn_IR_CON); /*жϱ־λ*/
            break;
          }
          else if(SocketIr & Sn_IR_DISCON)
          {
            setSn_IR(SOCKET_CMD, Sn_IR_DISCON); /*жϱ־λ*/
            break;
          }
          else if(SocketIr & Sn_IR_TIMEOUT)
          {
            setSn_IR(SOCKET_CMD, Sn_IR_TIMEOUT); /*жϱ־λ*/
            break;
          }
          if((GetSystemTick() - ConnectTick) > 10000)
            break;
          osDelay(50);
        }
        break;

      case SOCK_ESTABLISHED:/*socketӽ״̬*/
        if(0 == LastRecvTick)
          LastRecvTick = GetSystemTick();
        ResetNetTick = 0;
        if(getSn_IR(SOCKET_CMD) & Sn_IR_CON)
          setSn_IR(SOCKET_CMD, Sn_IR_CON); /*жϱ־λ*/
        FTP_Communicate();

        if((GetSystemTick() - LastRecvTick) > (2*60*1000))
          close(SOCKET_CMD);
        break;

      case SOCK_CLOSE_WAIT:/*socketڵȴر״̬*/
        close(SOCKET_CMD);
        break;

      default:
        break;
    }
    osDelay(15);
  }
}

void FtpUpgardeProcess(void)
{
  if(Ftp_flag)
  {
    if( (UserParam.FtpDataChn != 1) && (UserParam.FtpDataChn != 2) )
      UserParam.FtpDataChn = SOCKET_DAT;
    else
      SOCKET_DAT = UserParam.FtpDataChn;
    FTP_Run();
  }
}
