
#include "Thd_Charge.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Drv_Meter.h"


void ChgProCommError_AB(StructChargeCtrl *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CurrtCheckTick = 0;
  u32 DrainResistTick = 0;
  u32 CcStatusChkTick = 0;
  u8 ChgEndFlag = 0;

  u32 CST_SendTick = 0;
  u32 CEM_SendTick = 0;
  u32 CemSendCnt = 0;
  u32 CstSendCnt = 0;

  BsdMsg.Valid = 0;
  BmsCanInit();
  osDelay(5);

  ChargeTimerSet(eSwSta_Off);
  BmsPowerSet_AB(eSwSta_On);
  LockSet_AB(eSwSta_On);
  FanSet_AB(eSwSta_On);
  ImdWorkSet_AB(eSwSta_Off);
  DrainResistSet_AB(eSwSta_Off);
  //DcOutSet_AB(eSwSta_On);
  DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));

  CstSendCnt = 0;
  CST_Send(&CstMsg);
  CST_SendTick = GetSystemTick();

  CemSendCnt = 0;
  CEM_Send(&CemMsg);
  CEM_SendTick = GetSystemTick();

  CurrtCheckTick = GetSystemTick();
  DrainResistTick = 0;

  while(1)
  {
    if((0 != CST_SendTick) && ((GetSystemTick() - CST_SendTick) > 10))
    {
      CST_Send(&CstMsg);
      CST_SendTick = GetSystemTick();
      CstSendCnt++;
      if(CstSendCnt > 50)
        CST_SendTick = 0;
    }

    if((0 != CEM_SendTick) && ((GetSystemTick() - CEM_SendTick) > 250))
    {
      if(0 != CemMsg.Cem.Mult)//ͨŹ
        CEM_Send(&CemMsg);
      CEM_SendTick = GetSystemTick();
      CemSendCnt++;
      if(CemSendCnt > 5)
      {
        BmsPowerSet_AB(eSwSta_Off);
        CEM_SendTick = 0;
      }
    }

    ChgPgnRecv(&PgnRecv);

    if(0 != CurrtCheckTick)
    {
      if((GetDcModuleCurrt_AB() < 50) || ((GetSystemTick() - CurrtCheckTick) > 120))
      {//С5A
        DcOutSet_AB(eSwSta_Off);//k1 k2
        DrainResistSet_AB(eSwSta_On);//йŵ
        DrainResistTick = GetSystemTick();
        CurrtCheckTick = 0;
      }
    }

    if(0 != DrainResistTick)
    {
      if((GetDcModuleVolt_AB() < 600) || ((GetSystemTick() - DrainResistTick) > 4000))
      {//С60V
        DrainResistSet_AB(eSwSta_Off);
        ChgEndFlag = 1;
        DrainResistTick = 0;
      }
    }

    if((0 != ChgEndFlag) && (CemSendCnt > 5))
    {
      LockSet_AB(eSwSta_Off);
      FanSet_AB(eSwSta_Off);
    }

    if((0 == ChargeEnable_AB) && (0 != ChgEndFlag) && (CemSendCnt > 5))
    {//ⲿƽ
      pChargeCtrl->CurProcess = eChgPro_ChgIdle;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead_AB())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick))
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
      CcStatusChkTick = 0;
    }

    if((0 != PillarError.Value.Emergency) || (0 != PillarError_B.Value.Emergency))
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
    }
    if((0 != PillarError.Value.Door) || (0 != PillarError_B.Value.Door))
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
    }
    if((0 != PillarError.Value.Contactor) || (0 != PillarError_B.Value.Contactor))
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
    }
    if((0 != PillarError.Value.UniContactor) || (0 != PillarError_B.Value.UniContactor))
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
    }
    if((0 != PillarError.Value.InVolt) || (0 != PillarError_B.Value.InVolt))
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
    }
    if((0 != PillarError.Value.NoDcmod) || (0 != PillarError_B.Value.NoDcmod))
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
    }
    if((0 != PillarError.Value.Meter) || (0 != PillarError_B.Value.Meter))
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
    }

    if(eChgPro_AB_CommError != pChargeCtrl->CurProcess)
      return;

    osDelay(5);
  }
}

