
#include "Thd_Charge.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"


void ChgProCommBeak(StructChargeCtrl *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CEM_SendTick = 0;
  u32 CurrtCheckTick = 0;
  u32 ChgReStartTick = 0;
  u32 CcStatusChkTick = 0;

  if(0 == CommErrorCount)
  {
    CommErrFrame[0] = BemMsg.Bem.Mult;
    CommErrFrame[1] = CemMsg.Cem.Mult;
  }
  else if(1 == CommErrorCount)
  {
    CommErrFrame[2] = BemMsg.Bem.Mult;
    CommErrFrame[3] = CemMsg.Cem.Mult;
  }

  CommErrorCount++;
  if(CommErrorCount > 2)
  {
    CstMsg.StopReason.Value.Truble = 1;//ֹͣ
    CstMsg.StopTruble.Value.Other = 1;//  ͨųʱ
    ChargeStopType = eChgStop_ComBreak_CommError;
    pChargeCtrl->CurProcess = eChgPro_CommError;
    pChargeCtrl->Param = 0;
    return;
  }

  BstMsg.Valid = 0;
  BmsCanInit();
  osDelay(20);

  ChargeTimerSet(eSwSta_Off);
  BmsPowerSet(eSwSta_On);
  LockSet(eSwSta_On);
  FanSet(eSwSta_On);
  ImdWorkSet(eSwSta_Off);
  DrainResistSet(eSwSta_Off);
  //DcOutSet(eSwSta_On);
  DcModuleSet(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage.ValidNum);

  if(0 != CemMsg.Cem.Mult)
    CEM_Send(&CemMsg);
  CEM_SendTick = GetSystemTick();

  CurrtCheckTick = GetSystemTick();
  ChgReStartTick = 0;

  while(1)
  {
    if((0 != CEM_SendTick) && ((GetSystemTick() - CEM_SendTick) > 250))
    {
      if(0 != CemMsg.Cem.Mult)//ͨŹ
        CEM_Send(&CemMsg);
      CEM_SendTick = GetSystemTick();
    }

    ChgPgnRecv(&PgnRecv);

    if(GetDcModuleCurrt() < 50)//С5A
    {
      CurrtCheckTick = 0;
      if(0 == ChgReStartTick)
      {
        DcOutSet(eSwSta_Off);//k1 k2
        ChgReStartTick = GetSystemTick();
      }
    }
    else
    {
      if((0 != CurrtCheckTick) && ((GetSystemTick() - CurrtCheckTick) > 5000))
      {
        DcOutSet(eSwSta_Off);//k1 k2
        CurrtCheckTick = 0;
        CstMsg.StopReason.Value.Truble = 1;//ֹͣ
        CstMsg.StopTruble.Value.Other = 1;//  
        CstMsg.StopFault.Value.Currt = 1;//ƥ
        ChargeStopType = eChgStop_ComBreak_CurtError;
        pChargeCtrl->CurProcess = eChgPro_ChgBreak;
        pChargeCtrl->Param = 0;
      }
    }

    if((0 != ChgReStartTick) && ((GetSystemTick() - ChgReStartTick) > 3500))
    {
      pChargeCtrl->CurProcess = eChgPro_ChgRecognize;
      pChargeCtrl->Param = 0;
    }

    if(0 != BstMsg.Valid)
    {
      CstMsg.StopReason.Value.BmsStop = 1;
      ChargeStopType = eChgStop_ComBreak_BmsStop;
      pChargeCtrl->CurProcess = eChgPro_ChgStop;
      pChargeCtrl->Param = 0;
    }
    if(0 == TCUCurChgRecd.TCUChargeEnable)
    {//ⲿƽ
      CstMsg.StopReason.Value.Manual = 1;
      ChargeStopType = eChgStop_ComBreak_UserCancel;
      pChargeCtrl->CurProcess = eChgPro_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick))
    {
      DcOutSet(eSwSta_Off);
      CcStatusChkTick = 0;
      ChargeStopType = eChgStop_ComBreak_CcOpen;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Emergency)
    {
      DcOutSet(eSwSta_Off);
      ChargeStopType = eChgStop_ComBreak_EmerClose;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Door)
    {
      DcOutSet(eSwSta_Off);
      ChargeStopType = eChgStop_ComBreak_DoorOpen;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Contactor)
    {
      DcOutSet(eSwSta_Off);
      ChargeStopType = eChgStop_ComBreak_Contactor;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.UniContactor)
    {
      DcOutSet(eSwSta_Off);
      ChargeStopType = eChgStop_ComBreak_Contactor;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.InVolt)
    {
      DcOutSet(eSwSta_Off);
      ChargeStopType = eChgStop_ComBreak_InVolt;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.NoDcmod)
    {
      DcOutSet(eSwSta_Off);
      ChargeStopType = eChgStop_ComBreak_NoDcmod;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Meter)
    {
      DcOutSet(eSwSta_Off);
      ChargeStopType = eChgStop_ComBreak_Meter;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_CommBreak != pChargeCtrl->CurProcess)
      return;
    osDelay(25);
  }
}


