
#include "Thd_Charge.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Drv_Meter.h"
#include "Memory.h"
#include "Drv_ImdJyc.h"
s32 GetDCVoltBeforInsulation(void)
{
  if(ImdValue.Vaild)
    return ImdValue.PnVolt;
  else
  	return 1000;
}

void ChgProShakeHand(StructChargeCtrl *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CHM_SendTick = 0;
  u32 CcStatusChkTick = 0;
  u32 BHM_FirstRecv = 0;

//////Щô????
  //PillarError.Value.Insulation = 0;
  //PillarError.Value.ImdDev = 0;
  //PillarError.Value.DrainResist = 0;

  ChargeError.Value.DrainResist = 0;
  ChargeError.Value.IsolateWarn = 0;//Ե
  ChargeError.Value.IsolateError = 0;
  ChargeError.Value.VoltOutError = 0;
  ChargeError.Value.CurrtOutError = 0;

  memset(&BemMsg, 0, sizeof(BemMsg));
  memset(&CemMsg, 0, sizeof(CemMsg));
  memset(&BstMsg, 0, sizeof(BstMsg));
  memset(&CstMsg, 0, sizeof(CstMsg));
  memset(&BsdMsg, 0, sizeof(BsdMsg));
  memset(&CsdMsg, 0, sizeof(CsdMsg));

  CommErrorCount = 0;
  CommErrFrame[0] = 0;
  CommErrFrame[1] = 0;
  CommErrFrame[2] = 0;
  CommErrFrame[3] = 0;

  StartChgEnergy = MeterValue.Energy;
  StopChgEnergy  = MeterValue.Energy;

  ChargeStopType = eChgStop_None;

  BhmMsg.Valid = 0;
  BhmMsg.RecvTick = GetSystemTick();
  BHM_FirstRecv = 0;

  ChargeTimerSet(eSwSta_Off);
  CleanChgTimeCnt();
  BmsPowerSet(eSwSta_On);
  LockSet(eSwSta_On);
  FanSet(eSwSta_On);
  ImdWorkSet(eSwSta_On);
  DrainResistSet(eSwSta_Off);
  DcOutSet(eSwSta_Off);
  DcModuleSet(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage.ValidNum);

  BmsCanInit();
  osDelay(20);
 // u8 ShortCircuitCkeck  = 0 ;
  CHM_Send();
  CHM_SendTick = GetSystemTick();

  while(1)
  {
    if((0 != CHM_SendTick) && ((GetSystemTick() - CHM_SendTick) > 250))
    {
      CHM_Send();
      CHM_SendTick = GetSystemTick();
    }

    ChgPgnRecv(&PgnRecv);


    if(eChgVer_2011 != UserParam.ChgVer)
    {
      if(0 != BhmMsg.Valid)//¹
      {//ѾյBHMģ
        ChgVer = eChgVer_2015;
        if(0 == BHM_FirstRecv)
          BHM_FirstRecv = GetSystemTick();
        if(0 != ImdValue.Vaild)
        {
          if( GetDCVoltBeforInsulation() >100)
          {
      			ChargeStopType = eChgStop_Imd_IsolateError;
      			pChargeCtrl->CurProcess = eChgPro_ChgStop;
				TCUCurChgRecd.TCUChgStopType = 0x1c;
      			pChargeCtrl->Param = 0;
          }
    		  else
    		  {
           /* if(ShortCircuitCkeck == 0 )
            {
             ShortCirCheckSet(eSwSta_On);
             osDelay(1000);
             if(eSwSta_On==DcOutPosGet_Uni())
              {
               ShortCircuitCkeck = 1;
               ShortCirCheckSet(eSwSta_Off);
              }
             else
              {
                ChargeStopType = eChgStop_Imd_Short;
          			pChargeCtrl->CurProcess = eChgPro_ChgStop;
          			pChargeCtrl->Param = 0;
                ShortCirCheckSet(eSwSta_Off);
              }
            }
            else*/
            {
              pChargeCtrl->CurProcess = eChgPro_ImdCheck;
              pChargeCtrl->Param = 0;
            }
    		  }
        }
        else
        {
          if((GetSystemTick() - BHM_FirstRecv) > MsgTimeout_5S)
          {
            ChargeError.Value.IsolateWarn = 1;//Ե
            pChargeCtrl->CurProcess = eChgPro_ChgRecognize;
            pChargeCtrl->Param = 0;
          }
        }
      }
      else if((GetSystemTick() - BhmMsg.RecvTick) > MsgTimeout_5S)
      {//ɹ꣬ȶϿBmsپԵ
        ChgVer = eChgVer_2011;
        BmsPowerSet(eSwSta_Off);
        CHM_SendTick = 0;
        if(0 != ImdValue.Vaild)
        {
          pChargeCtrl->CurProcess = eChgPro_ImdCheck;
          pChargeCtrl->Param = 0;
        }
        else if((GetSystemTick() - BhmMsg.RecvTick) > (MsgTimeout_5S*3/2))
        {
          BmsPowerSet(eSwSta_On);
          pChargeCtrl->CurProcess = eChgPro_ChgRecognize;
          pChargeCtrl->Param = 0;
        }
      }
    }
    else
    {
      if(0 != BhmMsg.Valid)//¹
      {
        ChgVer = eChgVer_2015;
        if(0 == BHM_FirstRecv)
          BHM_FirstRecv = GetSystemTick();
        if((GetSystemTick() - BHM_FirstRecv) > MsgTimeout_5S)
        {
          pChargeCtrl->CurProcess = eChgPro_ChgRecognize;
          pChargeCtrl->Param = 0;
        }
      }
      else if((GetSystemTick() - BhmMsg.RecvTick) > (MsgTimeout_5S/2))
      {//ɹ
        ChgVer = eChgVer_2011;
        pChargeCtrl->CurProcess = eChgPro_ChgRecognizeEx;
        pChargeCtrl->Param = 0;
      }
    }

    if(0 == TCUCurChgRecd.TCUChargeEnable)
    {//ⲿƽ
      ChargeStopType = eChgStop_Shake_UserCancel;
      pChargeCtrl->CurProcess = eChgPro_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick * 2))
    {
      DcModuleSet(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage.ValidNum);
      DcOutSet(eSwSta_Off);
      CcStatusChkTick = 0;
      ChargeStopType = eChgStop_Shake_CcOpen;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Emergency)
    {
      DcModuleSet(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage.ValidNum);
      DcOutSet(eSwSta_Off);
      ChargeStopType = eChgStop_Shake_EmerClose;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Door)
    {
      DcModuleSet(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage.ValidNum);
      DcOutSet(eSwSta_Off);
      ChargeStopType = eChgStop_Shake_DoorOpen;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Contactor)
    {
      DcModuleSet(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage.ValidNum);
      DcOutSet(eSwSta_Off);
      ChargeStopType = eChgStop_Shake_Contactor;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.UniContactor)
    {
      DcModuleSet(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage.ValidNum);
      DcOutSet(eSwSta_Off);
      ChargeStopType = eChgStop_Shake_Contactor;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.InVolt)
    {
      DcModuleSet(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage.ValidNum);
      DcOutSet(eSwSta_Off);
      ChargeStopType = eChgStop_Shake_InVolt;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.NoDcmod)
    {
      DcModuleSet(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage.ValidNum);
      DcOutSet(eSwSta_Off);
      ChargeStopType = eChgStop_Shake_NoDcmod;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Meter)
    {
      DcModuleSet(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage.ValidNum);
      DcOutSet(eSwSta_Off);
      ChargeStopType = eChgStop_Shake_Meter;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_ShakeHand != pChargeCtrl->CurProcess)
      return;

    osDelay(25);
  }
}

