
#include "Thd_Charge_B.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Drv_Meter.h"

void ChgProChgBreak_B(StructChargeCtrl_B*pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CST_SendTick = 0;
  u32 DrainResistTick = 0;
  u8 ChgEndFlag = 0;
  u32 DtcSendTick = 0;
  u32 DtcSendCnt = 0;
  u32 Dtc = 0;
  u32 CstSendCnt = 0;

  BmsCanInit_B();
  osDelay(5);

  ChargeTimerSet_B(eSwSta_Off);
  BmsPowerSet_B(eSwSta_On);
  //BmsPowerSet_B(eSwSta_Off);
  LockSet_B(eSwSta_On);
  FanSet_B(eSwSta_On);
  ImdWorkSet_B(eSwSta_Off);
  DrainResistSet_B(eSwSta_On);
  DcOutSet_B(eSwSta_Off);
  DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);

  CST_Send_B(&CstMsg_B);
  CST_SendTick = GetSystemTick();
  CstSendCnt = 0;

  DtcSendCnt = 0;
  DtcSendTick = GetSystemTick();

  DrainResistTick = GetSystemTick();

  Dtc = 0;
  if((eChgStop_Shake_CcOpen == ChargeStopType_B)
      || (eChgStop_Imd_CcOpen == ChargeStopType_B)
      || (eChgStop_Reco_CcOpen == ChargeStopType_B)
      || (eChgStop_Conf_CcOpen == ChargeStopType_B)
      || (eChgStop_BmsReady_CcOpen == ChargeStopType_B)
      || (eChgStop_PillarReady_CcOpen == ChargeStopType_B)
      || (eChgStop_Start_CcOpen == ChargeStopType_B)
      || (eChgStop_Run_CcOpen == ChargeStopType_B)
      || (eChgStop_ComBreak_CcOpen == ChargeStopType_B))
  {
    Dtc = 0x01380DC2;
  }

  if((eChgStop_Shake_EmerClose == ChargeStopType_B)
      || (eChgStop_Imd_EmerClose == ChargeStopType_B)
      || (eChgStop_Reco_EmerClose == ChargeStopType_B)
      || (eChgStop_Conf_EmerClose == ChargeStopType_B)
      || (eChgStop_BmsReady_EmerClose == ChargeStopType_B)
      || (eChgStop_PillarReady_EmerClose == ChargeStopType_B)
      || (eChgStop_Start_EmerClose == ChargeStopType_B)
      || (eChgStop_Run_EmerClose == ChargeStopType_B)
      || (eChgStop_ComBreak_EmerClose == ChargeStopType_B))
  {
    Dtc = 0x01480DC2;
  }

  if((eChgStop_Shake_DoorOpen== ChargeStopType_B)
      || (eChgStop_Imd_DoorOpen == ChargeStopType_B)
      || (eChgStop_Reco_DoorOpen == ChargeStopType_B)
      || (eChgStop_Conf_DoorOpen == ChargeStopType_B)
      || (eChgStop_BmsReady_DoorOpen == ChargeStopType_B)
      || (eChgStop_PillarReady_DoorOpen == ChargeStopType_B)
      || (eChgStop_Start_DoorOpen == ChargeStopType_B)
      || (eChgStop_Run_DoorOpen == ChargeStopType_B)
      || (eChgStop_ComBreak_DoorOpen == ChargeStopType_B))
  {
    Dtc = 0x01500DC2;//10
  }


  if((eChgStop_Shake_Contactor == ChargeStopType_B)
      || (eChgStop_Imd_Contactor == ChargeStopType_B)
      || (eChgStop_Reco_Contactor == ChargeStopType_B)
      || (eChgStop_Conf_Contactor == ChargeStopType_B)
      || (eChgStop_BmsReady_Contactor == ChargeStopType_B)
      || (eChgStop_PillarReady_Contactor == ChargeStopType_B)
      || (eChgStop_Start_Contactor == ChargeStopType_B)
      || (eChgStop_Run_Contactor == ChargeStopType_B)
      || (eChgStop_ComBreak_Contactor == ChargeStopType_B))
  {
    Dtc = 0x01580DC2;//11
  }

  if((eChgStop_Shake_InVolt == ChargeStopType_B)
      || (eChgStop_Imd_InVolt== ChargeStopType_B)
      || (eChgStop_Reco_InVolt == ChargeStopType_B)
      || (eChgStop_Conf_InVolt == ChargeStopType_B)
      || (eChgStop_BmsReady_InVolt == ChargeStopType_B)
      || (eChgStop_PillarReady_InVolt == ChargeStopType_B)
      || (eChgStop_Start_InVolt == ChargeStopType_B)
      || (eChgStop_Run_InVolt == ChargeStopType_B)
      || (eChgStop_ComBreak_InVolt == ChargeStopType_B))
  {
    Dtc = 0x01600DC2;//12
  }

  while(1)
  {
    if((0 != CST_SendTick) && ((GetSystemTick() - CST_SendTick) > 10))
    {
      CST_Send_B(&CstMsg_B);
      CST_SendTick = GetSystemTick();
      CstSendCnt++;
      if(CstSendCnt > 50)
        CST_SendTick = 0;
    }

    if((0 != DtcSendTick) && ((GetSystemTick() - DtcSendTick) > 500))
    {
      DtcSendTick = GetSystemTick();
      DM1_Send_B(Dtc);
      DM3_Send_B(1);
      DtcSendCnt++;
      if(DtcSendCnt > 5)
      {
        BmsPowerSet_B(eSwSta_Off);
        DtcSendTick = 0;
      }
    }

    ChgPgnRecv_B(&PgnRecv);

    if(0 != DrainResistTick)
    {
      if((GetDcModuleVolt_B() < 600) || ((GetSystemTick() - DrainResistTick) > 4000))//С60V
      {
        DrainResistSet_B(eSwSta_Off);
        ChgEndFlag = 1;
        DrainResistTick = 0;
      }
    }

    if((0 != ChgEndFlag) && (DtcSendCnt > 5))
    {
      LockSet_B(eSwSta_Off);
      FanSet_B(eSwSta_Off);
    }

    if((0 == TCUCurChgRecd_B.TCUChargeEnable) && (0 != ChgEndFlag) && (DtcSendCnt > 5))
    {//ⲿƽ
      pChargeCtrl->CurProcess = eChgPro_B_ChgIdle;
      pChargeCtrl->Param = 0;
    }

    if(eChgPro_B_ChgBreak != pChargeCtrl->CurProcess)
      return;

    osDelay(5);
  }
}

