
#include "Thd_Charge_B.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Drv_Meter.h"


void ChgProCommError_B(StructChargeCtrl_B *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CurrtCheckTick = 0;
  u32 DrainResistTick = 0;
  u32 CcStatusChkTick = 0;
  u8 ChgEndFlag = 0;

  u32 CST_SendTick = 0;
  u32 CEM_SendTick = 0;
  u32 CemSendCnt = 0;
  u32 CstSendCnt = 0;

  BsdMsg_B.Valid = 0;
  BmsCanInit_B();
  osDelay(5);

  ChargeTimerSet_B(eSwSta_Off);
  BmsPowerSet_B(eSwSta_On);
  LockSet_B(eSwSta_On);
  FanSet_B(eSwSta_On);
  ImdWorkSet_B(eSwSta_Off);
  DrainResistSet_B(eSwSta_Off);
  //DcOutSet_B(eSwSta_On);
  DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);

  CstSendCnt = 0;
  CST_Send_B(&CstMsg_B);
  CST_SendTick = GetSystemTick();

  CemSendCnt = 0;
  CEM_Send_B(&CemMsg_B);
  CEM_SendTick = GetSystemTick();

  CurrtCheckTick = GetSystemTick();
  DrainResistTick = 0;

  while(1)
  {
    if((0 != CST_SendTick) && ((GetSystemTick() - CST_SendTick) > 10))
    {
      CST_Send_B(&CstMsg_B);
      CST_SendTick = GetSystemTick();
      CstSendCnt++;
      if(CstSendCnt > 50)
        CST_SendTick = 0;
    }

    if((0 != CEM_SendTick) && ((GetSystemTick() - CEM_SendTick) > 250))
    {
      if(0 != CemMsg_B.Cem.Mult)//ͨŹ
        CEM_Send_B(&CemMsg_B);
      CEM_SendTick = GetSystemTick();
      CemSendCnt++;
      if(CemSendCnt > 5)
      {
        BmsPowerSet_B(eSwSta_Off);
        CEM_SendTick = 0;
      }
    }

    ChgPgnRecv_B(&PgnRecv);

    if(0 != CurrtCheckTick)
    {
      if((GetDcModuleCurrt_B() < 50) || ((GetSystemTick() - CurrtCheckTick) > 120))
      {//С5A
        DcOutSet_B(eSwSta_Off);//k1 k2
        DrainResistSet_B(eSwSta_On);//йŵ
        DrainResistTick = GetSystemTick();
        CurrtCheckTick = 0;
      }
    }

    if(0 != DrainResistTick)
    {
      if((GetDcModuleVolt_B() < 600) || ((GetSystemTick() - DrainResistTick) > 4000))
      {//С60V
        DrainResistSet_B(eSwSta_Off);
        ChgEndFlag = 1;
        DrainResistTick = 0;
      }
    }

    if((0 != ChgEndFlag) && (CemSendCnt > 5))
    {
      LockSet_B(eSwSta_Off);
      FanSet_B(eSwSta_Off);
    }

    if((0 == TCUCurChgRecd_B.TCUChargeEnable) && (0 != ChgEndFlag) && (CemSendCnt > 5))
    {//ⲿƽ
      pChargeCtrl->CurProcess = eChgPro_B_ChgIdle;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead_B())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick_B))
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_B(eSwSta_Off);
      CcStatusChkTick = 0;
    }

    if(0 != PillarError_B.Value.Emergency)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_B(eSwSta_Off);
    }
    if(0 != PillarError.Value.Door)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_B(eSwSta_Off);
    }
    if(0 != PillarError.Value.Contactor)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_B(eSwSta_Off);
    }
    if(0 != PillarError.Value.UniContactor)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_B(eSwSta_Off);
    }
    if(0 != PillarError.Value.InVolt)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_B(eSwSta_Off);
    }
    if(0 != PillarError.Value.NoDcmod)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_B(eSwSta_Off);
    }
    if(0 != PillarError.Value.Meter)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_B(eSwSta_Off);
    }

    if(eChgPro_B_CommError != pChargeCtrl->CurProcess)
      return;

    osDelay(5);
  }
}

