

#include "Thd_Lcd.h"

#define ScrnChargeScreen_AB  ((u16)10)
#define BtnChargeScreen_AB_Cancel      ((u16)0x1001)
#define BtnChargeScreen_AB_Menu        ((u16)0x1002)

#define TxtChargeScreen_AB_CardNum         ((u16)0x4020)//Aǹ翨
#define VarChargeScreen_AB_CardMoney       ((u16)0x0003) //Aǹʣ

#define VarChargeScreenr_AB_EmployRate     ((u16)0x002D)
#define VarChargeScreenr_AB_FreeTime       ((u16)0x002E)

#define VarChargeScreenr_AB_TotalMoney     ((u16)0x0007)
#define VarChargeScreen_AB_energyRate      ((u16)0x0008)

#define DataChargeScreen_AB_Volt               ((u16)0x0021)
#define DataChargeScreen_AB_Currt              ((u16)0x0022)
#define DataChargeScreen_AB_RemainMin          ((u16)0x0024)
#define DataChargeScreen_AB_ChgMin             ((u16)0x0006)
#define DataChargeScreen_AB_ChgEnergy          ((u16)0x0005)
#define DataChargeScreen_AB_Soc                ((u16)0x0023)

#define TextChargeScreen_AB_ChgStatus             ((u16)0x4120)
#define TextChargeScreen_AB_DevStatus             ((u16)0x4140)

#define AnimChargeScreen_AB_Charge             ((u16)0x001A)

#define VarChargeScreen_AB_Position           ((u16)0x003C)

void ChargeScreenPaint_AB(void)
{
  char Str[64];
  u32 Temp,Temp1;
  u16 TempU16;

  LcdShowData16(VarChargeScreen_AB_Position, 3);

  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", pCurChgRecd_AB->CardNum[0],pCurChgRecd_AB->CardNum[1],
            pCurChgRecd_AB->CardNum[2], pCurChgRecd_AB->CardNum[3], pCurChgRecd_AB->CardNum[4], pCurChgRecd_AB->CardNum[5],
            pCurChgRecd_AB->CardNum[6], pCurChgRecd_AB->CardNum[7], pCurChgRecd_AB->CardNum[8], pCurChgRecd_AB->CardNum[9]);
  LcdShowStr(TxtChargeScreen_AB_CardNum, (u8*)&Str[0], (strlen(Str)+1));
  LcdShowData32(VarChargeScreen_AB_CardMoney, pCurChgRecd_AB->CardRespMoney);

  LcdShowData16(VarChargeScreenr_AB_EmployRate, UserParam.EmployRate);
  LcdShowData16(VarChargeScreenr_AB_FreeTime, UserParam.FreeTime);

  LcdShowData16(VarChargeScreenr_AB_TotalMoney, pCurChgRecd_AB->TotalMoney);

  //ȡʣ
  Temp = RtcGetTime()%(24*3600);//Сʱ
  Temp1=Temp = Temp/1800;//30
  if((UserParam.EnergyTimeRate[Temp] > 0) && (UserParam.EnergyTimeRate[Temp] < 5))
    Temp = UserParam.EnergyTimeRate[Temp] - 1;
  else
    Temp = 0;

   if((UserParam.ServerTimeRate[Temp1] > 0) && (UserParam.ServerTimeRate[Temp1] < 5))
    Temp1 = UserParam.ServerTimeRate[Temp1] - 1;
  else
    Temp1 = 0;
  LcdShowData16(VarChargeScreen_AB_energyRate, UserParam.EnergyRate[Temp] + UserParam.ServerRate2[Temp1]);

  TempU16 = pCurChgRecd_AB->ChgTime/60;//GetChgMin();
  LcdShowData16(DataChargeScreen_AB_ChgMin, TempU16);
  TempU16 = pCurChgRecd_AB->ChgEnergy/10;
  LcdShowData16(DataChargeScreen_AB_ChgEnergy, TempU16);
  TempU16 = BcsMsg.CurSoc;
  LcdShowData16(DataChargeScreen_AB_Soc, TempU16);

  TempU16 = GetDcModuleVolt_AB();
  LcdShowData16(DataChargeScreen_AB_Volt, TempU16);
  TempU16 = GetDcModuleCurrt_AB();
  LcdShowData16(DataChargeScreen_AB_Currt, TempU16);
  TempU16 = BcsMsg.RemainMin;
  LcdShowData16(DataChargeScreen_AB_RemainMin, TempU16);

  if((eChgPro_ChgIdle == ChargeCtrl.CurProcess)
      || (eChgPro_AB_ChgStop == ChargeCtrl.CurProcess)
      || (eChgPro_AB_ChgBreak == ChargeCtrl.CurProcess)
      || (eChgPro_AB_CommError == ChargeCtrl.CurProcess))
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(AnimChargeScreen_AB_Charge, TempU16);

  switch(ChargeStopType)
  {
//    case eChgStop_None:
//      snprintf(Str, sizeof(Str), "ڳ");
//      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
//      snprintf(Str, sizeof(Str), "");
//      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
//      break;

    case eChgStop_Shake_UserCancel:
    case eChgStop_Imd_UserCancel:
    case eChgStop_Reco_UserCancle:
    case eChgStop_Conf_UserCancel:
    case eChgStop_BmsReady_UserCancel:
    case eChgStop_PillarReady_UserCancel:
    case eChgStop_Start_UserCancel:
    case eChgStop_ComBreak_UserCancel:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ûȡ");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Shake_CcOpen:
    case eChgStop_Imd_CcOpen:
    case eChgStop_Reco_CcOpen:
    case eChgStop_Conf_CcOpen:
    case eChgStop_BmsReady_CcOpen:
    case eChgStop_PillarReady_CcOpen:
    case eChgStop_Start_CcOpen:
    case eChgStop_Run_CcOpen:
    case eChgStop_ComBreak_CcOpen:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ӶϿ");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Shake_EmerClose:
    case eChgStop_Imd_EmerClose:
    case eChgStop_Reco_EmerClose:
    case eChgStop_Conf_EmerClose:
    case eChgStop_BmsReady_EmerClose:
    case eChgStop_PillarReady_EmerClose:
    case eChgStop_Start_EmerClose:
    case eChgStop_Run_EmerClose:
    case eChgStop_ComBreak_EmerClose:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ͣť");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Conf_DoorOpen:
    case eChgStop_Reco_DoorOpen:
    case eChgStop_Run_DoorOpen:
    case eChgStop_Start_DoorOpen:
    case eChgStop_ComBreak_DoorOpen:
    case eChgStop_Imd_DoorOpen:
    case eChgStop_Shake_DoorOpen:
    case eChgStop_BmsReady_DoorOpen:
    case eChgStop_PillarReady_DoorOpen:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "׮Ŵ");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Conf_Contactor:
    case eChgStop_Reco_Contactor:
    case eChgStop_Run_Contactor:
    case eChgStop_Start_Contactor:
    case eChgStop_ComBreak_Contactor:
    case eChgStop_Imd_Contactor:
    case eChgStop_Shake_Contactor:
    case eChgStop_BmsReady_Contactor:
    case eChgStop_PillarReady_Contactor:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "׮Ŵ");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Conf_InVolt:
    case eChgStop_Reco_InVolt:
    case eChgStop_Run_InVolt:
    case eChgStop_Start_InVolt:
    case eChgStop_ComBreak_InVolt:
    case eChgStop_Imd_InVolt:
    case eChgStop_Shake_InVolt:
    case eChgStop_BmsReady_InVolt:
    case eChgStop_PillarReady_InVolt:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ѹ쳣");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Conf_NoDcmod:
    case eChgStop_Reco_NoDcmod:
    case eChgStop_Run_NoDcmod:
    case eChgStop_Start_NoDcmod:
    case eChgStop_ComBreak_NoDcmod:
    case eChgStop_Imd_NoDcmod:
    case eChgStop_Shake_NoDcmod:
    case eChgStop_BmsReady_NoDcmod:
    case eChgStop_PillarReady_NoDcmod:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "޳ģ");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Conf_Meter:
    case eChgStop_Reco_Meter:
    case eChgStop_Run_Meter:
    case eChgStop_Start_Meter:
    case eChgStop_ComBreak_Meter:
    case eChgStop_Imd_Meter:
    case eChgStop_Shake_Meter:
    case eChgStop_BmsReady_Meter:
    case eChgStop_PillarReady_Meter:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ֱ쳣");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Conf_StartSoc98:
      snprintf(Str, sizeof(Str), "%d ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "Soc");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Conf_BatVoltOverPermitMax:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "صѹѹ");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Conf_StartVoltOverPillarMax:
    case eChgStop_PillarReady_BatVoltOverPillarMax:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "صѹڳ׮ѹ");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Start_BmsStop:
    case eChgStop_Run_BmsStop:
      snprintf(Str, sizeof(Str), "%d ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "Bmsֹͣ%02X %04X %02X", BstMsg.StopReason.Mult, BstMsg.StopTruble.Mult, BstMsg.StopFault.Mult);
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Run_Soc98:
      snprintf(Str, sizeof(Str), "%d ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "Ѿ");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_ComBreak_CurtError:
      snprintf(Str, sizeof(Str), "%d ֹ%04X %04X", ChargeStopType, BemMsg.Bem.Mult, CemMsg.Cem.Mult);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "쳣");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_ComBreak_BmsStop:
      snprintf(Str, sizeof(Str), "%d ֹ%08X %08X", ChargeStopType, BemMsg.Bem.Mult, CemMsg.Cem.Mult);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "Bmsֹͣ%02X %04X %02X", BstMsg.StopReason.Mult, BstMsg.StopTruble.Mult, BstMsg.StopFault.Mult);
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Imd_BhmTimeOut:
    case eChgStop_ComBreak_CommError:
      snprintf(Str, sizeof(Str), "%d ֹ%08X %08X", ChargeStopType, BemMsg.Bem.Mult, CemMsg.Cem.Mult);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ͨŹ");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Imd_IsolateError:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "׮Ե");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Run_SinglBatVoltOverPermitMax:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "صѹֵ");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Run_SinglBatVolt:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "صѹ쳣");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Run_SocOver:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "SOC쳣");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Run_CurrtOver:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "س쳣");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Run_BatTempOver:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "¶ȹ");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Run_BatIsolate:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ؾԵ쳣");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Run_Cc2Error:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "Ӽ쳣");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Run_BmsPause:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ͣʱ");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Conf_ChgMaxVoltLessPillarMinVolt:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ѹƥ");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_PillarReady_BatVoltError:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_PillarReady_BatVoltMismatchBcpVolt:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "Bcpѹʵʲ");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Run_VoltOutHighErr:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "׮ѹ");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Run_CurrtOutHighErr:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "׮");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Run_UserCancel:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));
      //if(pCurChgRecd_AB->TotalMoney >= pCurChgRecd_AB->CardRespMoney)
      if(5 == pCurChgRecd_AB->ChgStopType)
        snprintf(Str, sizeof(Str), "");
      //else if(160 == pCurChgRecd_AB->ChgStopType)
      //  snprintf(Str, sizeof(Str), "׮ͨѶ쳣");
      else if(23 == pCurChgRecd_AB->ChgStopType)
        snprintf(Str, sizeof(Str), "ȡ쳣");
	  else if (pCurChgRecd_AB->ChgStopType == 3)
	  	snprintf(Str, sizeof(Str), "ﵽSOC趨ֵ");
      else
        snprintf(Str, sizeof(Str), "ûȡ");
      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    default:
      if(eChgPro_ChgIdle == ChargeCtrl.CurProcess)
        snprintf(Str, sizeof(Str), "ֹͣ");
      else if (eChgPro_AB_ChgStop == ChargeCtrl.CurProcess)
        snprintf(Str, sizeof(Str), "");
      else if(eChgPro_AB_ChgBreak == ChargeCtrl.CurProcess)
        snprintf(Str, sizeof(Str), "ֹ");
      else if(eChgPro_AB_CommError== ChargeCtrl.CurProcess)
        snprintf(Str, sizeof(Str), "ֹ");
      else
        snprintf(Str, sizeof(Str), "ڳ");
      LcdShowStr(TextChargeScreen_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));

      if(1 == ChargeError.Value.IsolateError)
        snprintf(Str, sizeof(Str), "׮Ե");
      else if(1 == ChargeError.Value.IsolateWarn)
        snprintf(Str, sizeof(Str), "ԵС");
      else if(1 == ChargeError.Value.DrainResist)
        snprintf(Str, sizeof(Str), "йŵ辯");
      else if(eChgPro_ChgIdle == ChargeCtrl.CurProcess)
        snprintf(Str, sizeof(Str), "鳵׮Ƿƥ");
      else if (eChgPro_AB_ChgStop == ChargeCtrl.CurProcess)
        snprintf(Str, sizeof(Str), "鳵׮Ƿƥ");
      else if(eChgPro_AB_ChgBreak == ChargeCtrl.CurProcess)
        snprintf(Str, sizeof(Str), "鳵׮Ƿƥ");
      else if(eChgPro_AB_CommError== ChargeCtrl.CurProcess)
        snprintf(Str, sizeof(Str), "鳵׮Ƿƥ");
      else if(PillarError.Value.EleLock)
        snprintf(Str, sizeof(Str), "Aǹ쳣");
      else if(PillarError_B.Value.EleLock)
        snprintf(Str, sizeof(Str), "Bǹ쳣");
      else
        snprintf(Str, sizeof(Str), "");

      LcdShowStr(TextChargeScreen_AB_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
  }

  LcdShowPage(ScrnChargeScreen_AB);
}

typedef struct
{
  u32 RePainTick;
}StructChargeScreenUpdate;

void ChargeScreenUpdate_AB(StructChargeScreenUpdate *pUpdate)
{
  if((GetSystemTick() - pUpdate->RePainTick) >= 1590)
  {
    pUpdate->RePainTick = GetSystemTick();

    ChargeScreenPaint_AB();
  }
}
static  u32 ChgEnergyCheckValue_AB = 0;
static  u32 EnergyCheckTick_AB = 0;

static void EnergyCheckpPer30S_AB(void)
{
  

  if(GetDcModuleCurrt_AB() > 100)
  	{
  	 if(GetSystemTick()-EnergyCheckTick_AB > 60*1000)//30S
      {
        EnergyCheckTick_AB = GetSystemTick();
        if(pCurChgRecd_AB->ChgEnergy > ChgEnergyCheckValue_AB)
        ChgEnergyCheckValue_AB = pCurChgRecd_AB->ChgEnergy;
        else
        {
          ChargeEnable= 0;
          pCurChgRecd_AB->ChgStopType = 23;//
        }
      }
  	}
  else
  {
  	EnergyCheckTick_AB = GetSystemTick();
  	ChgEnergyCheckValue_AB = pCurChgRecd_AB->ChgEnergy;
  }
}

u32 UnconnectTick_AB;
#define UnconnectTime   (3500)//20S   //ⲻCC/CP Ͽֹͣ 

void LcdProChargeScreen_AB(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;
  StructChargeScreenUpdate Update;

  u32 BtnManageTick;
  u8  BtnManageCounter;

  StructTime Time;
  u32 TimeSynTick;

  u32 TempRecdTick;

  pCurChgRecd_AB = &CurChgRecd;

  TempChgRecdSaveToLog(pCurChgRecd_AB, 1, 1);
  TempRecdTick = GetSystemTick();

  //IdleLedSet(eSwSta_Off);
  //ChgLedSet(eSwSta_On);

  ScreenChkTick = GetSystemTick();

  ChargeScreenPaint_AB();
  Update.RePainTick = GetSystemTick();

  BtnManageTick = GetSystemTick();
  BtnManageCounter = 0;
  EnergyCheckTick_AB = GetSystemTick();
  ChgEnergyCheckValue_AB = pCurChgRecd_AB->ChgEnergy;
  TimeSynTick = GetSystemTick();
  LcdGetRtc();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnChargeScreen_AB != Temp)
              LcdShowPage(ScrnChargeScreen_AB);
          }
          else if(eLcdRegAddr_Rtc == Frame.Ctrl.RdReg.Addr)
          {
            Time.Year = 2000 + BcdToHex(Frame.Ctrl.RdReg.Data[0]);          //  
            Time.Mon = BcdToHex(Frame.Ctrl.RdReg.Data[1] & 0x1F);      //  
            Time.Day = BcdToHex(Frame.Ctrl.RdReg.Data[2] & 0x3F);      //  
                    //Frame.Ctrl.RdReg.Data[3]
            Time.Hour = BcdToHex(Frame.Ctrl.RdReg.Data[4] & 0x3F);      //  Сʱ
            Time.Min = BcdToHex(Frame.Ctrl.RdReg.Data[5] & 0x7F);      //  
            Time.Sec = BcdToHex(Frame.Ctrl.RdReg.Data[6] &0x7F);      //  

            RtcSetTime(GetExtOrLcdStamp(&Time));
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnChargeScreen_AB_Cancel:
                pLcdCtrl->CurScreen = eLcdPro_AB_SwipeCard;
                //pLcdCtrl->CurScreen = eLcdPro_AB_PutBack;
                pLcdCtrl->Param = 0;
                break;
              case BtnChargeScreen_AB_Menu:
                if((GetSystemTick() - BtnManageTick) >= 1000)
                  BtnManageCounter = 0;
                else
                {
                  BtnManageCounter++;
                  if(BtnManageCounter > 2)
                  {
                    pLcdCtrl->CurScreen = eLcdPro_AB_BmsInfor;
                    pLcdCtrl->Param = 0;
                  }
                }
                BtnManageTick = GetSystemTick();
                break;
              default:
                LcdShowPage(ScrnChargeScreen_AB);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if(eSwSta_On != CcStatusRead_AB())
    {
      if(0 == UnconnectTick_AB)
        UnconnectTick_AB = GetSystemTick();
    }
    else
      UnconnectTick_AB = 0;
    if((0 != UnconnectTick_AB) && (GetSystemTick() - UnconnectTick_AB) > UnconnectTime)
    {
      pCurChgRecd_AB->ChgStopType = 4;//ǹֹͣ  "׮CC/CPźŶϿֱ׮CC1ȷ϶Ͽ"  4

      pLcdCtrl->CurScreen = eLcdPro_AB_PutBack;
      pLcdCtrl->Param = 0;
    }

    /*if(0 != PillarError.Value.PillarComm)
    {
      ChargeEnable_AB = 0;
      pCurChgRecd_AB->ChgStopType = 160;//׮ͨѶ쳣ֹͣ 160
    }*/

    //if((1 == pCurChgRecd_AB->CardValidFlag) && (pCurChgRecd_AB->TotalMoney >= pCurChgRecd_AB->CardRespMoney))
    if(pCurChgRecd_AB->TotalMoney >= (pCurChgRecd_AB->CardRespMoney - UserParam.BalanceMoney))
    {
      ChargeEnable_AB = 0;
      pCurChgRecd_AB->ChgStopType = 5;//ֹͣ  ôﵽ˻ֹͣ  5
    }
    if((BcsMsg.CurSoc >= UserParam.SOCMAX)&&(BclMsg.Valid ==1))
    {
      ChargeEnable = 0;
      pCurChgRecd_AB->ChgStopType = 3;//ﵽsoc趨ֵ
     }
    if(eLcdPro_AB_ChargeScreen != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if((GetSystemTick() - TimeSynTick) >= RtcSynTime)
    {
      TimeSynTick = GetSystemTick();
      LcdGetRtc();
    }

    if((GetSystemTick() - TempRecdTick) > 60*1000)
    {
      TempChgRecdSaveToLog(pCurChgRecd_AB, 1, 1);
      TempRecdTick = GetSystemTick();
    }

    ChargeScreenUpdate_AB(&Update);
    EnergyCheckpPer30S_AB();

    osDelay(100);
  }
}


