
#include "Thd_Lcd.h"


#define ScrnBuildComm  ((u16)9)
#define BtnBuildComm_Cancel      ((u16)0x0901)

#define AnimBuildCommAddr_Start  ((u16)0x0020)

#define VarBulidComm_Position    ((u16)0x003C)
void BuildCommPaint(void)
{

  LcdShowData16(VarBulidComm_Position, UserParam.ChgFun.Value.Num_B);

  LcdShowData16(AnimBuildCommAddr_Start, 0);
  LcdShowPage(ScrnBuildComm);
}

void BuildCommIdle(void)
{

}

void LcdProBuildComm(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;

  ChargeStopType = eChgStop_None;
  memset(&BcpMsg ,0,sizeof(BcpMsg));
  memset(&BclMsg ,0,sizeof(BclMsg));
  memset(&BcsMsg ,0,sizeof(BcsMsg));
  memset(&BsmMsg ,0,sizeof(BsmMsg));
  memset(&BsdMsg ,0,sizeof(BsdMsg));
  memset(&BrmMsg ,0,sizeof(BrmMsg));

  if((0x88 == CurChgRecd.CardNum[0]) && (0x80 == (CurChgRecd.CardNum[1] & 0x80)))
    CurChgRecd.MoneyDecFlag = 0;
  else
    CurChgRecd.MoneyDecFlag = 2;   //0δۿ 1¿ۿ 2̨
  CurChgRecd.ChgStopType = 0;     //ֹͣ   //1ˢ 2Զ 4ǹ

  //CurChgRecd.ChgType = 0;      // 0=Ȼ 1=Զʱ磻2=Զ 3=Զ
  //CurChgRecd.ChgTypeParam = 0; //Բ0=Ȼ磨01=Զʱ䣨1s/bit2=Զ0.001Kwh/bit3=Զ1/bit

  CurChgRecd.ChgEnergy = 0;    //ۻ 0.001kWh/bit
  CurChgRecd.ChgTime = 0;      //ۻʱ 1s/bit

  //CurChgRecd.RespMaxChgEnergy = 0xFFFFFFFF;     //֤ɳ
  //CurChgRecd.RespMaxChgTime = 0xFFFFFFFF; //֤ɳʱ

  CurChgRecd.WipeStartTime = RtcGetTime();  //ˢʼʱ 0δˢ 0 ˢʱ׼ʱ

  CurChgRecd.WipeStopTime = 0;  //ˢʱ 0δˢ 0 ˢʱ׼ʱ
  CurChgRecd.ChgStartTime = RtcGetTime(); //翪ʼʱ 0δʼ 0翪ʼʱʱ
  CurChgRecd.ChgStopTime = RtcGetTime(); //ʱ 0δʼ 0ʱʱ

  CurChgRecd.StartMeterEnergy = MeterValue.Energy*10;  //ʼܱ 0.001kWh/bit
  CurChgRecd.StopMeterEnergy = MeterValue.Energy*10;   //ܱ 0.001kWh/bit

//  CurChgRecd.StartCardMoney = 0;    //翨
//  CurChgRecd.StopCardMoney = 0;    //翨
  CurChgRecd.EnergyMoney = 0;  //ѽ
  CurChgRecd.ServeMoney = 0;   //ѽ
  CurChgRecd.EmployMoney = 0;   //׮ռý
  CurChgRecd.TotalMoney = 0;   //ѽ

  CurChgRecd.ChgServerUpCtrl = 0;
  CurChgRecd.ChgRecUpCtrl = 0;

  CurChgRecd.RecordValid = 1;

  CurChgRecd.ChgStartNoteCtrl = 0;
  CurChgRecd.ChgStopNotetrl = 0;

  ChargeEnable = 1;
  ChargePauseFlag = 0;

  BuzzerRun(1, 800, 100);
  //IdleLedSet(eSwSta_Off);
  //ChgLedSet(eSwSta_On);
  ScreenChkTick = GetSystemTick();
  BuildCommPaint();

  TempChgRecdSaveToLog(&CurChgRecd, 1, 1);

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnBuildComm != Temp)
              LcdShowPage(ScrnBuildComm);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnBuildComm_Cancel:
                ChargeEnable = 0;
                //pLcdCtrl->CurScreen = eLcdPro_ChargeSummary;//eLcdPro_MainMenu;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_ChargeSummary);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnBuildComm);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    switch(ChargeCtrl.CurProcess)
    {
      case eChgPro_ChgRun:
      case eChgPro_WaitVoltChgRun:
        CurChgRecd.ChgStartNoteCtrl = 1;
        //pLcdCtrl->CurScreen = eLcdPro_ChargeSummary;
        pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_ChargeSummary);
        pLcdCtrl->Param = 0;
        break;
      case eChgPro_ChgStop://ʶ
      case eChgPro_CommError:
      case eChgPro_ChgBreak:
        //pLcdCtrl->CurScreen = eLcdPro_ChargeSummary;//eLcdPro_CommError;
        pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_ChargeSummary);
        pLcdCtrl->Param = 0;
        break;
      default:
        break;
    }

    if(ChargeStopType == eChgStop_ComBreak_CommError)
    {
      pLcdCtrl->CurScreen = eLcdPro_CommError;
      pLcdCtrl->Param = 1;
    }

    if(eLcdPro_BuildComm != pLcdCtrl->CurScreen)
      return;

    BuildCommIdle();

    osDelay(100);
  }
}



