
/******************************************************************************
ļ  : Lcd_CardSure_A.c
  : Һʾ棬Aǹˢ
  :
޸  : 2015-04-10      

******************************************************************************/

#include "Thd_Lcd.h"


#define ScrnCardSure      ((u16)6) //Aǹˢ

#define TextCardSure_CardNum   ((u16)0x4020)

#define TxtCardSure_Tip       ((u16)0x4000)

#define VarCardSure_Counter            ((u16)0x0002)

#define VarCardSure_Position           ((u16)0x003C)
static void CardSurePaint(void)
{
  char Str[32] = {0};
  LcdShowData16(VarCardSure_Position, UserParam.ChgFun.Value.Num_B);

  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", CardData.CardNum[0],CardData.CardNum[1],
    CardData.CardNum[2], CardData.CardNum[3], CardData.CardNum[4], CardData.CardNum[5],
    CardData.CardNum[6], CardData.CardNum[7], CardData.CardNum[8], CardData.CardNum[9]);
  LcdShowStr(TextCardSure_CardNum, (u8*)Str, strlen(Str)+1);

  LcdShowNum(VarCardSure_Counter, 25);

  snprintf(Str, sizeof(Str), "Ժ");
  LcdShowStr(TxtCardSure_Tip, (u8*)Str, strlen(Str)+1);
  LcdShowPage(ScrnCardSure);
}

static void CardSureIdle(void)
{

}

void LcdProCardSure(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;

  char Str[32] = {0};
  u8 TimeOutTick;
  u8 Time;

  u8 RespFlag = 0;//0δ֤, 1лظ2֤ʱ

  TimeOutTick = 255;//180*100ms = 10
  Time = 25;

  memset(&CurChgRecd, 0, sizeof(CurChgRecd));
  memcpy(CurChgRecd.CardNum, CardData.CardNum, 16);
  memcpy(CurChgRecd.CardPwd, CardData.CardPwd, 6);
  CurChgRecd.StartCardMoney = 0;//CardData.CardMoney;
  CurChgRecd.StopCardMoney = 0;//CardData.CardMoney;
  CurChgRecd.CardSureCtrl = 1;//

  osDelay(500);

  CardSurePaint();

  while(1)
  {
    if(TimeOutTick > 0)
      TimeOutTick--;
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              default:
                LcdShowPage(ScrnCardSure);
                break;
            }
          }
          else
            LcdShowPage(ScrnCardSure);
          break;

        default:
          break;
      }
    }

    if(1 != RespFlag)
    {
      if(3 == CurChgRecd.CardSureCtrl)
      {
        if(0 == CurChgRecd.CardResp)
        {//֤ͨ
          CurChgRecd.CardValidFlag = 1;
          CurChgRecd.StartCardMoney = CurChgRecd.CardRespMoney;
          CurChgRecd.StartCardMoney = CurChgRecd.CardRespMoney;
          CurChgRecd.StopCardMoney = CurChgRecd.CardRespMoney;
          pLcdCtrl->CurScreen = eLcdPro_CnctDetect;
          pLcdCtrl->Param = 0;
        }
        else
        {//1֤ͨ
          if(1 == CurChgRecd.CardResp)
            snprintf(Str, sizeof(Str), "Ч");
          else if(2 == CurChgRecd.CardResp)
            snprintf(Str, sizeof(Str), "˻%.2fԪ,㡣", ((float)CurChgRecd.CardRespMoney/100));
          else if(3 == CurChgRecd.CardResp)
            snprintf(Str, sizeof(Str), "űᡣ");
          else if(4 == CurChgRecd.CardResp)
            snprintf(Str, sizeof(Str), "ܾ");
          else if(5 == CurChgRecd.CardResp)
            snprintf(Str, sizeof(Str), "");
          else
            snprintf(Str, sizeof(Str), "֤˻쳣");

          LcdShowStr(TxtCardSure_Tip, (u8*)Str, strlen(Str)+1);

          BuzzerRun(3, 200, 100);
          TimeOutTick = 39;
        }
        RespFlag = 1;
      }
    }

    if(eLcdPro_CardSure != pLcdCtrl->CurScreen)
      return;

    if((TimeOutTick) < 5)
    {
      if(0 == RespFlag)
      {//2֤ʱ
        snprintf(Str, sizeof(Str), "˺֤ʱ");
        LcdShowStr(TxtCardSure_Tip, (u8*)Str, strlen(Str)+1);

        RespFlag = 2;
        TimeOutTick = 39;
      }
      else
      {
//        pLcdCtrl->CurScreen = eLcdPro_MainMenu;
        pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
        pLcdCtrl->Param = 0;
      }
    }

    Temp = TimeOutTick/10;
    if(Time != Temp)
    {
      Time = Temp;
      LcdShowNum(VarCardSure_Counter, Time);
    }

    CardSureIdle();

    osDelay(100);
  }
}




