
/******************************************************************************
ļ  : Lcd_InforLogClean.c
  : Һʾ棬Aǹˢ
  :
޸  : 2015-04-10      

******************************************************************************/

#include "Thd_Lcd.h"

#define PageInforLogClean            ((u16)47)
#define BtnInforLogClean_Enter       ((u16)0x4701)
#define BtnInforLogClean_Cancel      ((u16)0x4702)

#define TxtInforLogClean_Tip         ((u16)0x4000)   //A ǹϢ

//#define BtnInforLogClean_Next        ((u16)0x020A)
//#define BtnInforLogClean_Last       ((u16)0x020B)




void InforLogCleanPaint(void)
{
  char Str[64] = {0};

  snprintf(Str, sizeof(Str), "δϴ%d%d", WaitUpChgRecdNum, LogChgRecdParam.Num);
  LcdShowStr(TxtInforLogClean_Tip, (u8*)Str, strlen(Str)+1);

  LcdShowPage(PageInforLogClean);
}

void InforLogCleanIdle(void)
{

}

#define TimeOutTime   (30*1000)

void LcdProInforLogClean(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;

  TimeOutTick = GetSystemTick();
  InforLogCleanPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnInforLogClean_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnInforLogClean_Enter:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                LogParamReset();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(PageInforLogClean);
                break;
            }
          }
          else
            LcdShowPage(PageInforLogClean);
          break;

        default:
          break;
      }
    }

    if(eLcdPro_InforLogClean != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      TimeOutTick = GetSystemTick();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    InforLogCleanIdle();

    osDelay(100);
  }
}









