
#ifndef __THD_TCUCONTROL_H__
#define __THD_TCUCONTROL_H__

#include "Global.h"
#include "Drv_Adc.h"

#include "Drv_ImdJyc.h"
#include "Thd_TCU.h"


typedef enum
{
  eLcdPro_TCUMainMenu = 0,
  eLcdPro_TCUPrstart,
  eLcdPro_TCUPrstart_B,
  eLcdPro_TCUBuildComm,
  eLcdPro_TCUBuildComm_B,
  eLcdPro_TCUChargeSummary,
  eLcdPro_TCUChargeSummary_B,
  eLcdPro_TCUChargeSummary_AB,
 // eLcdPro_TCUChargeStop,
 // eLcdPro_TCUChargeStopComp,
 // eLcdPro_TCUChargeStop_B,
 // eLcdPro_TCUChargeStopComp_B,
  
  eLcdPro_TCUMax,
}EnumTCUProcess;

typedef struct
{
  EnumTCUProcess CurScreen;
  u8 Param;//void *Param;
}StructTCUCtrl;

typedef void (*pTCUCtrlHandle)(StructTCUCtrl *pTCUCtrl);

#include "Memory.h"
#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Thd_Charge.h"
#include "Thd_Charge_B.h"
#include "Drv_Meter.h"
#include "Drv_ReaderActR1.h"
#include "Drv_Buzzer.h"
#include "Drv_LcdDwin.h"
#include "Drv_Dht12.h"
#include "Drv_RtcExt.h"

#include "Drv_CommuUSART3.h"
typedef struct{
 u8 TCUChgStartNotetrl ;//ʶ
 u8 StarValid;//ǷЧ
 u8 StarChgType;//ʼ//弴ʶ  00 01 弴other:invalid
 u8 StarChgResult;//
 
 u8 TCUChargeEnable;//BMSʹܱ־
 u8 TCUStartCompresult;//
 u8 TCUChgStarCompNotetrl ;//ʶ
 
 u8 TCUChgStopType;//0δֹֹͣͣԭ
 u8 TCUChgStopNotetrl;//ͣʶ
 u8 TCUChgStopCompNotetrl; //翪ʼ״̬ϴ  0Ҫ 1ȴ 2ѷ 3ѻظ

}StructTCUChgRecd;




extern StructTCUCtrl TCUCtrl;

extern StructTCUChgRecd TCUCurChgRecd;
extern StructTCUChgRecd TCUCurChgRecd_B;

/*extern u32 RtcGetTime(void);
extern void RtcSetTime(u32 TimeStamp);
extern void StampToTime(u32 TimeStamp, StructTime *pTimeBlock);
extern u32 TimeToStamp(StructTime *pTimeBlock);
extern u32 GetExtOrLcdStamp(StructTime *pTime);*/
extern void Thd_TCUControl(void const *parameter);


#endif


