
#include "Drv_CommuUart.h"

pCommuUartIrqHandler CommuUartIrq;

void USART3_IRQHandler(void)
{
  if(NULL != CommuUartIrq)
    CommuUartIrq();
  else
  {
    u16 CR1,SR;
    vu8 Data;

    SR = CommuUart_USARTx->SR;
    CR1 = CommuUart_USARTx->CR1;
    if((CR1 & USART_CR1_RXNEIE) && (SR & USART_SR_RXNE))
    {
      Data = (u8)CommuUart_USARTx->DR;
    }

    if((CR1 & USART_CR1_TXEIE) && (SR & USART_SR_TXE))
      CommuUart_USARTx->CR1 &= ~USART_CR1_TXEIE;
  }
}

void CommuUartIrqSet(pCommuUartIrqHandler Irq)
{
  CommuUartIrq = Irq;
}



