#ifndef __DRV_COMMUUART_H__
#define __DRV_COMMUUART_H__

#include "Global.h"

#define CommuUart_USARTx                           USART3
#define CommuUart_USARTx_CLK                       RCC_APB1Periph_USART3
#define CommuUart_USARTx_CLK_INIT                  RCC_APB1PeriphClockCmd
#define CommuUart_USARTx_IRQn                      USART3_IRQn

#define CommuUart_USARTx_TX_PIN                    GPIO_Pin_8
#define CommuUart_USARTx_TX_GPIO_PORT              GPIOD
#define CommuUart_USARTx_TX_GPIO_CLK               RCC_APB2Periph_GPIOD

#define CommuUart_USARTx_RX_PIN                    GPIO_Pin_9
#define CommuUart_USARTx_RX_GPIO_PORT              GPIOD
#define CommuUart_USARTx_RX_GPIO_CLK               RCC_APB2Periph_GPIOD

typedef void (*pCommuUartIrqHandler)(void);

extern void CommuUartIrqSet(pCommuUartIrqHandler Irq);

#endif

