
#ifndef __DRV_E2ROM_H__
#define __DRV_E2ROM_H__

#include "Global.h"

#define E2rom_SCL_GPIO_CLK               RCC_AHB1Periph_GPIOF
#define E2rom_SCL_GPIO_PORT              GPIOF
#define E2rom_SCL_PIN                    GPIO_Pin_1

#define E2rom_SDA_GPIO_CLK               RCC_AHB1Periph_GPIOF
#define E2rom_SDA_GPIO_PORT              GPIOF
#define E2rom_SDA_PIN                    GPIO_Pin_0

#define E2rom_SlaveAddr                  (0xA0)
#define E2rom_PageSize                   (128)

typedef enum
{
  eE2romErr_Sucess = 0, //ɹ
  eE2romErr_DataPiont,  //ָΪ
  eE2romErr_WriteOver,  //дݳΧ
  eE2romErr_ReadOver,   //ݳΧ
  eE2romErr_BusErr,     //ߴ
  eE2romErr_WriteCmd,   //豸ӵַдӦ
  eE2romErr_ReadCmd,    //豸ӵַӦ
  eE2romErr_RegAddrHi,  //ĴߵַӦ
  eE2romErr_RegAddrLo,  //Ĵ͵ַӦ
  eE2romErr_WriteData,  //дӦ
  eE2romErr_Error,      //
}EnumE2romError;

extern u8 E2romInit(void);
extern EnumE2romError E2romWriteData(u16 Addr, u8 *pData, u16 Len);
extern EnumE2romError E2romReadData(u16 Addr, u8 *pData, u16 Len);

#endif

