#ifndef __DRV_ELOCK_H__
#define __DRV_ELOCK_H__

#include "Global.h"

/**************************Elock pin********************************/
#define Elock_A_PIN            GPIO_Pin_4
#define Elock_A_PORT           GPIOE
#define Elock_A_RCC            RCC_APB2Periph_GPIOE

#define Elock_B_PIN            GPIO_Pin_3
#define Elock_B_PORT           GPIOE
#define Elock_B_RCC            RCC_APB2Periph_GPIOE


extern void ElockInit(void);
extern void ElockSetStatus_A(EnumSwitchStatus Status);
extern EnumSwitchStatus ElockGetStatus_A(void);
extern void ElockSetStatus_B(EnumSwitchStatus Status);
extern EnumSwitchStatus ElockGetStatus_B(void);

extern void ElockSetStatus(EnumSwitchStatus Status);
extern EnumSwitchStatus ElockGetStatus(void);

#endif


