
#ifndef __DRV_INTERNET_H__
#define __DRV_INTERNET_H__

#include "Global.h"
#include "Thd_Charge.h"
#include "Memory.h"

#define __ProtocolVer__   (0x0104)
#define __PillarType__    (0x03)//((0 == UserParam.ChgFun.Value.Num_B)?0x02:0x03)//(0x03)//0ǹ  0x00   1˫ǹ  0x01  2. ֱǹ  0x02  3. ֱ˫ǹ  0x03


typedef enum
{
  eCmd_cSendPillarSignIn    = 0xA1,//ǩ
  eCmd_sAckPillarSignIn     = 0xA2,//ǩӦ
  eCmd_cSendHeartBeat       = 0x51,//Զ
  eCmd_sAckHeartBeat        = 0x52,//ԶӦ

  eCmd_cSendPillarStatus    = 0x40,//׮״̬Ϣϱ
  eCmd_sAckPillarStatus     = 0x41,//Ӧ׮״̬Ϣ
  eCmd_cSendCardSure        = 0x75,//׮ϴˢ
  eCmd_sAckCardSure         = 0x76,//׮ϴˢӦ
  eCmd_cSendChgRecord       = 0x54,//ϴ
  eCmd_sAckChgRecord        = 0x55,//ϴӦ
  eCmd_cSendAwaitChgRecd    = 0x42,//ϴ
  eCmd_sAckAwaitChgRecd     = 0x43,//ϴӦ

  eCmd_cSendStartTransaction= 0x11,//ϴ
  eCmd_sAckStartTransaction = 0x56,//ϴӦ
  eCmd_cSendStopTransaction = 0x13,//ֹͣϴ
  eCmd_sAckStopTransaction  = 0x57,//ֹͣϴӦ
  eCmd_cSendCancelReserve   = 0x17,//ȡԤԼϴ
  eCmd_sAckCancelReserve    = 0x58,//ȡԤԼϴӦ
  eCmd_cSendPillarSignOut   = 0xA3,//˳¼
  eCmd_sAckPillarSignOut    = 0xA4,//˳¼Ӧ

  eCmd_sReqStartTransaction = 0x10,//Զ
  eCmd_cAckStartTransaction = 0x20,//ԶӦ
  eCmd_sReqStopTransaction  = 0x12,//Զֹͣ
  eCmd_cAckStopTransaction  = 0x21,//ԶֹͣӦ
  eCmd_sReqReserveNow       = 0x14,//ԤԼ
  eCmd_cAckReserveNow       = 0x15,//ԤԼӦ
  eCmd_sReqCancelReserve    = 0x16,//ȡԤԼ
  eCmd_cAckCancelReserve    = 0x17,//ȡԤԼӦ
  eCmd_sReqTimeSyn          = 0x34,//ʱͬ
  eCmd_cAckTimeSyn          = 0x35,//ʱͬӦ

  eCmd_sReqPillarReset      = 0x18,//·ָ
  eCmd_cAckPillarReset      = 0x19,//·ָӦ
  eCmd_sReqGetServerIp      = 0x30,//·ѯӲIP
  eCmd_cAckGetServerIp      = 0x31,//·ѯӲIPӦ
  eCmd_sReqSetServerIp      = 0x32,//·ӲIP
  eCmd_cAckSetServerIp      = 0x33,//·ӲIPӦ
  eCmd_sReqGetRate          = 0x36,//·ѯ
  eCmd_cAckGetRate          = 0x37,//·ѯӦ
  eCmd_sReqSetRate          = 0x38,//·÷
  eCmd_cAckSetRate          = 0x39,//·÷Ӧ
  eCmd_sReqSetQrcode        = 0x77,//·Ӫά
  eCmd_cAckSetQrcode        = 0x78,//·ӪάӦ
  eCmd_cReqSetMoneyKey      = 0x92,//·ܳ
  eCmd_cAckSetMoneyKey      = 0x93,//·ܳӦ

  eCmd_sReqReadyToUpdate    = 0x80,//·׼ָ
  eCmd_cAckReadyToUpdate    = 0x81,//·׼ָӦ
  eCmd_sReqFileInformation  = 0x82,//·ļСϢָ
  eCmd_cAckFileInformation  = 0x83,//·ļСϢָӦ
  eCmd_sSendPackData        = 0x84,//·ļָ
  eCmd_cAckPackData         = 0x85,//·ļָӦ
  eCmd_sSendFileEnd         = 0x86,//·ļݽָ
  eCmd_cAckFileEnd          = 0x87,//·ļݽָӦ
  eCmd_sReqUpdateFinish     = 0x88,//·ָ
  eCmd_cAckUpdateFinish     = 0x89,//·ָӦ
//FTP
  eCmd_FtpUpgrade           = 0x8A,//´·Ϣ
  eCmd_FtpUpgradeAck        = 0x8B,//豸ķϢӦ

  eCmd_cSendBatInfor        = 0x1B,//·ָӦ

}EnumInternetCmd;

//豸״̬
typedef enum
{
  eEventCode_None       = 0x00,//¼
  eEventCode_PowerOn    = 0x01,//ϵ 0x01 ⲿ220V Դưϵ
  eEventCode_ShutDown   = 0x02,//ػ 0x02 220V ⲿԴϿ
  eEventCode_SelTest    = 0x03,//Լ 0x03 ɳԼ
  eEventCode_WipeCard   = 0x04,//ˢ 0x04 ˢ
  eEventCode_ChgStart   = 0x05,//翪ʼ 0x05 ʴޱΪ
  eEventCode_ChgStop    = 0x06,// 0x06 ʴбΪ
  eEventCode_Repair     = 0x07,// 0x07 ϣ̬תΪ״̬
  eEventCode_UpDate     = 0x08,// 0x08 
  eEventCode_SetParam   = 0x09,// 0x09 òͨⲿָ˵
  eEventCode_OldRecdSend= 0x0A,//ݲ 0x0A 洢ڱصδüϴ̨̨
  eEventCode_DelRecord  = 0x0B,//ɾʷ 0x0B 洢ڱصݽɾǲ
  eEventCode_GetRecord  = 0x0C,//ʷݵ 0x0C ͨⲿ洢洢ڱصݽ˵
}EnumEventCode;

typedef struct
{
  u8 (*pNetInit)(osMessageQId AppRecvQ);
  u8 (*pNetAvail)(void);
  void (*pNetClose)(void);
  int (*pNetSend)(u8 *pData, u16 Len);
}StructNetDrv;

extern StructNetDrv *pNetDrv;

extern u8 InternetInit(void);
extern u8 InternetFrameRecv(u8 *pFrame);
extern u8 NetAvail(void);
extern void NetClose(void);

//(0x10) ϵͳѯǩϱ
extern int SendPillarSignIn(u8 ChgNum);

//(0x58) ԶϢϱ
extern int SendHeartBeat(u8 ChgNum);

extern int SendPillarStatus(u8 ChgNum);

//(0x78)׮նϱ¼
extern int SendChgRecord(u8 ChgNum);

//¼
extern int SendAwaitChgRecd(StructAwaitChgRecdLog *pChgLog);

//(0x42) ׮նʱͬ
extern int AckStartTransaction(u8 *pFrame, u32 Resp);
//(0x42) ׮նʱͬ
extern int AckStopTransaction(u8 *pFrame, u32 Resp);
//(0x42) ׮նʱͬ
extern int AckReserveNow(u8 *pFrame, u32 Resp);
extern int AckCancelReserve(u8 *pFrame, u32 Resp);
//(0x42) ׮նʱͬ
extern int AckPillarTimeSet(u8 *pFrame, u32 Resp);
extern int AckSetQrcode(u8 *pFrame);

extern int AckPillarReset(u8 *pFrame);

//(0x42) ׮նʱͬ
extern int SendStartTransaction(u8 ChgNum);
extern int SendStopTransaction(u8 ChgNum);
extern int SendCancelReserve(u8 ChgNum);
extern int SendPillarSignOut(void);

extern int AckGetServerIp(u8 *pFrame);
extern int AckSetServerIp(u8 *pFrame, u32 Resp);


extern int AckGetRate(u8 *pFrame);
extern int AckSetRate(u8 *pFrame, u32 Resp);

//ˢϴ֤
extern int SendCardSure(u8 ChgNum);
extern int AckSetMoneyKey(u8 *pFrame, u32 Resp);

extern int SendBatInfor(u8 ChgNum);
extern void FtpUpgradeAck(u8 *pFrame, u8 state);

#endif




