
#ifndef __DRV_LED_H__
#define __DRV_LED_H__

#include "Global.h"

//#ifdef __FourLed__
#define Led_Ready_PIN                   GPIO_Pin_7//E1//E0
#define Led_Ready_GPIO_PORT             GPIOE
#define Led_Ready_GPIO_CLK              RCC_APB2Periph_GPIOE

#define Led_Charge_PIN                  GPIO_Pin_8//E0//B9
#define Led_Charge_GPIO_PORT            GPIOE
#define Led_Charge_GPIO_CLK             RCC_APB2Periph_GPIOE

#define Led_Fault_1_PIN                 GPIO_Pin_9//B9//E1
#define Led_Fault_1_GPIO_PORT           GPIOE
#define Led_Fault_1_GPIO_CLK            RCC_APB2Periph_GPIOE
/*#else
#define Led_Ready_PIN                   GPIO_Pin_1//E1//E0
#define Led_Ready_GPIO_PORT             GPIOE
#define Led_Ready_GPIO_CLK              RCC_APB2Periph_GPIOE

#define Led_Charge_PIN                  GPIO_Pin_0//E0//B9
#define Led_Charge_GPIO_PORT            GPIOE
#define Led_Charge_GPIO_CLK             RCC_APB2Periph_GPIOE

#define Led_Fault_1_PIN                 GPIO_Pin_9//B9//E1
#define Led_Fault_1_GPIO_PORT           GPIOB
#define Led_Fault_1_GPIO_CLK            RCC_APB2Periph_GPIOB
#endif
*/
#define Led_Fault_2_PIN                 GPIO_Pin_10
#define Led_Fault_2_GPIO_PORT           GPIOE
#define Led_Fault_2_GPIO_CLK            RCC_APB2Periph_GPIOE

#define Led_Fault_3_PIN                 GPIO_Pin_11
#define Led_Fault_3_GPIO_PORT           GPIOE
#define Led_Fault_3_GPIO_CLK            RCC_APB2Periph_GPIOE

#define Led_Fault_4_PIN                 GPIO_Pin_12
#define Led_Fault_4_GPIO_PORT           GPIOE
#define Led_Fault_4_GPIO_CLK            RCC_APB2Periph_GPIOE


#define LedReadyOff()      GPIO_ResetBits(Led_Ready_GPIO_PORT, Led_Ready_PIN)
#define LedReadyOn()     GPIO_SetBits(Led_Ready_GPIO_PORT, Led_Ready_PIN)
#define LedChargeOff()     GPIO_ResetBits(Led_Charge_GPIO_PORT, Led_Charge_PIN)
#define LedChargeOn()    GPIO_SetBits(Led_Charge_GPIO_PORT, Led_Charge_PIN)

#define LedFault_1_Off()   GPIO_ResetBits(Led_Fault_1_GPIO_PORT, Led_Fault_1_PIN)
#define LedFault_1_On()  GPIO_SetBits(Led_Fault_1_GPIO_PORT, Led_Fault_1_PIN)
#define LedFault_2_Off()   GPIO_ResetBits(Led_Fault_2_GPIO_PORT, Led_Fault_2_PIN)
#define LedFault_2_On()  GPIO_SetBits(Led_Fault_2_GPIO_PORT, Led_Fault_2_PIN)
#define LedFault_3_On()   GPIO_ResetBits(Led_Fault_3_GPIO_PORT, Led_Fault_3_PIN)
#define LedFault_3_Off()  GPIO_SetBits(Led_Fault_3_GPIO_PORT, Led_Fault_3_PIN)
#define LedFault_4_On()   GPIO_ResetBits(Led_Fault_4_GPIO_PORT, Led_Fault_4_PIN)
#define LedFault_4_Off()  GPIO_SetBits(Led_Fault_4_GPIO_PORT, Led_Fault_4_PIN)

#define LedErrorOn()      LedFault_1_On()
#define LedErrorOff()     LedFault_1_Off()
#define NetLedOn()        LedFault_2_On()
#define NetLedOff()       LedFault_2_Off()

extern void LedInit(void);

#endif

