
#include "Thd_Charge_B.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Drv_Meter.h"
#include "Memory.h"
#include "Drv_ImdJyc.h"
s32 GetDCVoltBeforInsulation_B(void)
{
  if((ImdValue_B.Vaild))
    return ImdValue_B.PnVolt;
  else
  	return 1000;
}


void ChgProShakeHand_B(StructChargeCtrl_B *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CHM_SendTick = 0;
  u32 CcStatusChkTick = 0;
  u32 BHM_FirstRecv = 0;

//////Щô????
  //PillarError_B.Value.Insulation = 0;
  //PillarError_B.Value.ImdDev = 0;
  //PillarError_B.Value.DrainResist = 0;

  ChargeError_B.Value.DrainResist = 0;
  ChargeError_B.Value.IsolateWarn = 0;//Ե
  ChargeError_B.Value.IsolateError = 0;
  ChargeError_B.Value.VoltOutError = 0;
  ChargeError_B.Value.CurrtOutError = 0;

  memset(&BemMsg_B, 0, sizeof(BemMsg_B));
  memset(&CemMsg_B, 0, sizeof(CemMsg_B));
  memset(&BstMsg_B, 0, sizeof(BstMsg_B));
  memset(&CstMsg_B, 0, sizeof(CstMsg_B));
  memset(&BsdMsg_B, 0, sizeof(BsdMsg_B));
  memset(&CsdMsg_B, 0, sizeof(CsdMsg_B));

  CommErrorCount_B = 0;
  CommErrFrame_B[0] = 0;
  CommErrFrame_B[1] = 0;
  CommErrFrame_B[2] = 0;
  CommErrFrame_B[3] = 0;

  StartChgEnergy_B = MeterValue_B.Energy;
  StopChgEnergy_B  = MeterValue_B.Energy;

  ChargeStopType_B = eChgStop_None;

  BhmMsg_B.Valid = 0;
  BhmMsg_B.RecvTick = GetSystemTick();
  BHM_FirstRecv = 0;
 // u8 ShortCircuitCkeck = 0;
  ChargeTimerSet_B(eSwSta_Off);
  CleanChgTimeCnt_B();
  BmsPowerSet_B(eSwSta_On);
  LockSet_B(eSwSta_On);
  FanSet_B(eSwSta_On);
  ImdWorkSet_B(eSwSta_On);
  DrainResistSet_B(eSwSta_Off);
  DcOutSet_B(eSwSta_Off);
  DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);

  BmsCanInit_B();
  osDelay(20);

  CHM_Send_B();
  CHM_SendTick = GetSystemTick();

  while(1)
  {
    if((0 != CHM_SendTick) && ((GetSystemTick() - CHM_SendTick) > 250))
    {
      CHM_Send_B();
      CHM_SendTick = GetSystemTick();
    }

    ChgPgnRecv_B(&PgnRecv);


    if(eChgVer_2011 != UserParam.ChgVer)
    {
      if(0 != BhmMsg_B.Valid)//¹
      {//ѾյBHMģ
        ChgVer_B = eChgVer_2015;
        if(0 == BHM_FirstRecv)
          BHM_FirstRecv = GetSystemTick();
        if(0 != ImdValue_B.Vaild)
        {
          if( GetDCVoltBeforInsulation_B() >100)
          {
            ChargeStopType_B= eChgStop_Imd_IsolateError;
            pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
			TCUCurChgRecd_B.TCUChgStopType = 0x1c;
            pChargeCtrl->Param = 0;
          }
          else
          {

          /*  if(ShortCircuitCkeck == 0 )
            {
              ShortCirCheckSet(eSwSta_On);

               osDelay(1000);
              if(eSwSta_On == DcOutNegGet_Uni())
              {
               ShortCircuitCkeck = 1;
                ShortCirCheckSet(eSwSta_Off);
              }
              else
              {
                ChargeStopType_B=  eChgStop_Imd_Short;
                pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
                pChargeCtrl->Param = 0;
                ShortCirCheckSet(eSwSta_Off);
              }
            }
            else*/
            {
              pChargeCtrl->CurProcess = eChgPro_B_ImdCheck;
              pChargeCtrl->Param = 0;
            }
          }
        }
        else
        {
          if((GetSystemTick() - BHM_FirstRecv) > MsgTimeout_B_5S)
          {
            ChargeError_B.Value.IsolateWarn = 1;//Ե
            pChargeCtrl->CurProcess = eChgPro_B_ChgRecognize;
            pChargeCtrl->Param = 0;
          }
        }
      }
      else if((GetSystemTick() - BhmMsg_B.RecvTick) > MsgTimeout_B_5S)
      {//ɹ꣬ȶϿBmsپԵ
        ChgVer_B = eChgVer_2011;
        BmsPowerSet_B(eSwSta_Off);
        CHM_SendTick = 0;
        if(0 != ImdValue_B.Vaild)
        {
          pChargeCtrl->CurProcess = eChgPro_B_ImdCheck;
          pChargeCtrl->Param = 0;
        }
        else if((GetSystemTick() - BhmMsg_B.RecvTick) > (MsgTimeout_B_5S*3/2))
        {
          BmsPowerSet_B(eSwSta_On);
          pChargeCtrl->CurProcess = eChgPro_B_ChgRecognize;
          pChargeCtrl->Param = 0;
        }
      }
    }
    else
    {
      if(0 != BhmMsg_B.Valid)//¹
      {
        ChgVer_B = eChgVer_2015;
        if(0 == BHM_FirstRecv)
          BHM_FirstRecv = GetSystemTick();
        if((GetSystemTick() - BHM_FirstRecv) > MsgTimeout_B_5S)
        {
          pChargeCtrl->CurProcess = eChgPro_B_ChgRecognize;
          pChargeCtrl->Param = 0;
        }
      }
      else if((GetSystemTick() - BhmMsg_B.RecvTick) > (MsgTimeout_B_5S/2))
      {//ɹ
        ChgVer_B = eChgVer_2011;
        pChargeCtrl->CurProcess = eChgPro_B_ChgRecognizeEx;
        pChargeCtrl->Param = 0;
      }
    }

    if(0 == TCUCurChgRecd_B.TCUChargeEnable)
    {//ⲿƽ
      ChargeStopType_B = eChgStop_Shake_UserCancel;
      pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead_B())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick_B * 2))
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_B(eSwSta_Off);
      CcStatusChkTick = 0;
      ChargeStopType_B = eChgStop_Shake_CcOpen;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Emergency)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet(eSwSta_Off);
      ChargeStopType_B = eChgStop_Shake_EmerClose;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Door)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet(eSwSta_Off);
      ChargeStopType_B = eChgStop_Shake_DoorOpen;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Contactor)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet(eSwSta_Off);
      ChargeStopType_B = eChgStop_Shake_Contactor;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.UniContactor)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet(eSwSta_Off);
      ChargeStopType_B = eChgStop_Shake_Contactor;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.InVolt)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet(eSwSta_Off);
      ChargeStopType_B = eChgStop_Shake_InVolt;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.NoDcmod)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet(eSwSta_Off);
      ChargeStopType_B = eChgStop_Shake_NoDcmod;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Meter)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet(eSwSta_Off);
      ChargeStopType_B = eChgStop_Shake_Meter;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_B_ShakeHand != pChargeCtrl->CurProcess)
      return;

    osDelay(25);
  }
}

