
#include "Thd_Lcd.h"


#define ScrnBuildComm_AB  ((u16)9)
#define BtnBuildComm_AB_Cancel      ((u16)0x0901)

#define AnimBuildCommAddr_AB_Start  ((u16)0x0020)

#define VarBulidComm_AB_Position    ((u16)0x003C)
void BuildCommPaint_AB(void)
{

  LcdShowData16(VarBulidComm_AB_Position, 3);

  LcdShowData16(AnimBuildCommAddr_AB_Start, 0);
  LcdShowPage(ScrnBuildComm_AB);
}

void BuildCommIdle_AB(void)
{

}

void LcdProBuildComm_AB(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;

  ChargeStopType = eChgStop_None;
  memset(&BcpMsg ,0,sizeof(BcpMsg));
  memset(&BclMsg ,0,sizeof(BclMsg));
  memset(&BcsMsg ,0,sizeof(BcsMsg));
  memset(&BsmMsg ,0,sizeof(BsmMsg));
  memset(&BsdMsg ,0,sizeof(BsdMsg));
  memset(&BrmMsg ,0,sizeof(BrmMsg));

  pCurChgRecd_AB = &CurChgRecd;

  if((0x88 == pCurChgRecd_AB->CardNum[0]) && (0x80 == (pCurChgRecd_AB->CardNum[1] & 0x80)))
    pCurChgRecd_AB->MoneyDecFlag = 0;
  else
    pCurChgRecd_AB->MoneyDecFlag = 2;   //0δۿ 1¿ۿ 2̨
  pCurChgRecd_AB->ChgStopType = 0;     //ֹͣ   //1ˢ 2Զ 4ǹ

  //pCurChgRecd_AB->ChgType = 0;      // 0=Ȼ 1=Զʱ磻2=Զ 3=Զ
  //pCurChgRecd_AB->ChgTypeParam = 0; //Բ0=Ȼ磨01=Զʱ䣨1s/bit2=Զ0.001Kwh/bit3=Զ1/bit

  pCurChgRecd_AB->ChgEnergy = 0;    //ۻ 0.001kWh/bit
  pCurChgRecd_AB->ChgTime = 0;      //ۻʱ 1s/bit

  //pCurChgRecd_AB->RespMaxChgEnergy = 0xFFFFFFFF;     //֤ɳ
  //pCurChgRecd_AB->RespMaxChgTime = 0xFFFFFFFF; //֤ɳʱ

  pCurChgRecd_AB->WipeStartTime = RtcGetTime();  //ˢʼʱ 0δˢ 0 ˢʱ׼ʱ

  pCurChgRecd_AB->WipeStopTime = 0;  //ˢʱ 0δˢ 0 ˢʱ׼ʱ
  pCurChgRecd_AB->ChgStartTime = RtcGetTime(); //翪ʼʱ 0δʼ 0翪ʼʱʱ
  pCurChgRecd_AB->ChgStopTime = RtcGetTime(); //ʱ 0δʼ 0ʱʱ

  pCurChgRecd_AB->StartMeterEnergy = (MeterValue.Energy + MeterValue_B.Energy)*10;  //ʼܱ 0.001kWh/bit
  pCurChgRecd_AB->StopMeterEnergy = (MeterValue.Energy + MeterValue_B.Energy)*10;   //ܱ 0.001kWh/bit

//  pCurChgRecd_AB->StartCardMoney = 0;    //翨
//  pCurChgRecd_AB->StopCardMoney = 0;    //翨
  pCurChgRecd_AB->EnergyMoney = 0;  //ѽ
  pCurChgRecd_AB->ServeMoney = 0;   //ѽ
  pCurChgRecd_AB->EmployMoney = 0;   //׮ռý
  pCurChgRecd_AB->TotalMoney = 0;   //ѽ

  pCurChgRecd_AB->ChgServerUpCtrl = 0;
  pCurChgRecd_AB->ChgRecUpCtrl = 0;

  pCurChgRecd_AB->RecordValid = 1;

  pCurChgRecd_AB->ChgStartNoteCtrl = 0;
  pCurChgRecd_AB->ChgStopNotetrl = 0;

  ChargeEnable_AB = 1;
  ChargePauseFlag = 0;

  BuzzerRun(1, 800, 100);
  //IdleLedSet(eSwSta_Off);
  //ChgLedSet(eSwSta_On);
  ScreenChkTick = GetSystemTick();
  BuildCommPaint_AB();

  TempChgRecdSaveToLog(pCurChgRecd_AB, 1, 1);

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnBuildComm_AB != Temp)
              LcdShowPage(ScrnBuildComm_AB);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnBuildComm_AB_Cancel:
                ChargeEnable_AB = 0;
                pLcdCtrl->CurScreen = eLcdPro_AB_ChargeScreen;//eLcdPro_MainMenu;
                //pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_AB_ChargeSummary);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnBuildComm_AB);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    switch(ChargeCtrl.CurProcess)
    {
      case eChgPro_AB_ChgRun:
      case eChgPro_AB_WaitVoltChgRun:
        pCurChgRecd_AB->ChgStartNoteCtrl = 1;
        pLcdCtrl->CurScreen = eLcdPro_AB_ChargeScreen;
        //pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_AB_ChargeSummary);
        pLcdCtrl->Param = 0;
        break;
      case eChgPro_AB_ChgStop:
      case eChgPro_AB_CommError:
      case eChgPro_AB_ChgBreak:
        pLcdCtrl->CurScreen = eLcdPro_AB_ChargeScreen;//eLcdPro_CommError;
        //pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_AB_ChargeSummary);
        pLcdCtrl->Param = 0;
        break;
      default:
        break;
    }

    if(ChargeStopType == eChgStop_ComBreak_CommError)
    {
      pLcdCtrl->CurScreen = eLcdPro_CommError;
      pLcdCtrl->Param = 3;
    }

    if(eLcdPro_AB_BuildComm != pLcdCtrl->CurScreen)
      return;

    BuildCommIdle_AB();

    osDelay(100);
  }
}



