
#include "Thd_Lcd.h"


#define ScrnCardPwd_AB           ((u16)5) //Aǹˢ
#define BtnCardPwd_AB_Cancle     ((u16)0x0501)

#define TextCardPwd_AB_CardNum   ((u16)0x4020)
#define DataCardPwd_AB_Money     ((u16)0x0001)
#define TextCardPwd_AB_Tip       ((u16)0x4000)

#define TextCardPwd_AB_Pwd        ((u16)0x3000)
#define InputCardPwd_AB_Pwd       ((u16)0x3008)

#define VarCardPwd_AB_Position    ((u16)0x003C)
extern void CloseKeyBoard(void);

void CardPwdPaint_AB(void)
{
  char Str[64] = {0};
  LcdShowData16(VarCardPwd_AB_Position, 3);

  memset(Str, 0xFF, sizeof(Str));
  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", CardData.CardNum[0],CardData.CardNum[1],
    CardData.CardNum[2], CardData.CardNum[3], CardData.CardNum[4], CardData.CardNum[5],
    CardData.CardNum[6], CardData.CardNum[7], CardData.CardNum[8], CardData.CardNum[9]);
  LcdShowStr(TextCardPwd_AB_CardNum, (u8*)Str, strlen(Str)+1);

  LcdShowData32(DataCardPwd_AB_Money, CardData.CardMoney);

  snprintf(Str, sizeof(Str), "***");
  LcdWriteVar(TextCardPwd_AB_Pwd, (u8*)Str, strlen(Str)+1);

  snprintf(Str, sizeof(Str), "롣");
  LcdShowStr(TextCardPwd_AB_Tip, (u8*)Str, strlen(Str)+1);

  LcdShowPage(ScrnCardPwd_AB);
}

void CardPwdIdle_AB(void)
{

}

#define TimeOutTime   (30*1000)

void LcdProCardPwd_AB(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;

  char Str[64] = {0};

  pCurChgRecd_AB = &CurChgRecd;

  TimeOutTick = GetSystemTick();
  CardPwdPaint_AB();


  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnCardPwd_AB_Cancle:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_MainMenu;
                //pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnCardPwd_AB);
                break;
            }
          }
          else if(InputCardPwd_AB_Pwd == Temp)
          {
            if((Frame.Ctrl.RdVar.Len < 4) || ((4 == Frame.Ctrl.RdVar.Len) &&  (00 == Frame.Ctrl.RdVar.Data[7])))
            {
              snprintf(Str, sizeof(Str), "***");
              LcdWriteVar(TextCardPwd_AB_Pwd, (u8*)Str, strlen(Str)+1);
              snprintf(Str, sizeof(Str), "볤Ȳ㣬䡣");
              LcdShowStr(TextCardPwd_AB_Tip, (u8*)Str, strlen(Str)+1);
            }
            else
            {
              snprintf(Str, sizeof(Str), "******");
              LcdWriteVar(TextCardPwd_AB_Pwd, (u8*)Str, strlen(Str)+1);

              if((0x88 == CardData.CardNum[0]) && (0x80 == (CardData.CardNum[1] & 0x80)))
              {
                if(0 == memcmp(CardData.CardPwd, Frame.Ctrl.RdVar.Data, 6))
                {
                  memset(pCurChgRecd_AB, 0, sizeof(StructChgRecd));
                  memcpy(pCurChgRecd_AB->CardNum, CardData.CardNum, 16);
                  memcpy(pCurChgRecd_AB->CardPwd, CardData.CardPwd, 6);
                  pCurChgRecd_AB->CardRespMoney = CardData.CardMoney;
                  pCurChgRecd_AB->StartCardMoney = CardData.CardMoney;
                  pCurChgRecd_AB->StopCardMoney = CardData.CardMoney;
                  pCurChgRecd_AB->CardValidFlag = 1;
                  pLcdCtrl->CurScreen = eLcdPro_AB_CnctDetect;
                  pLcdCtrl->Param = 0;
                }
                else
                {
                  snprintf(Str, sizeof(Str), "䡣");
                  LcdShowStr(TextCardPwd_AB_Tip, (u8*)Str, strlen(Str)+1);
                  BuzzerRun(3, 200, 100);
                }
              }
              else
              {
                memcpy(CardData.CardPwd, Frame.Ctrl.RdVar.Data, 6);
                pLcdCtrl->CurScreen = eLcdPro_AB_CardSure;//eLcdPro_CnctDetect;
                pLcdCtrl->Param = 0;
              }
            }
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_AB_CardPwd != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      TimeOutTick = GetSystemTick();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      //pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }

    CardPwdIdle_AB();

    osDelay(100);
  }
}



