
#include "Thd_Lcd.h"
#include "Thd_InternetBsb.h"


#define ScrnPutBack_B          ((u16)14)  //Aǹ  ״̬
#define ScrnElectLock_B        ((u16)18)


#define BtnPutBack_B_Cancle     ((u16)0x0019)
#define DataPutBack_B_Counter   ((u16)0x0003)

#define TextPutBack_B_CardNum       ((u16)0x4020)

#define DataPutBack_B_ChgMin        ((u16)0x0006)
#define DataPutBack_B_ChgEnergy     ((u16)0x0005)
#define DataPutBack_B_Soc           ((u16)0x0023)

#define DataPutBack_B_EmployMoney   ((u16)0x002F)
#define DataPutBack_B_EnergyMoney   ((u16)0x000F)
#define DataPutBack_B_ServeMoney    ((u16)0x0010)
#define DataPutBack_B_TotalMoney    ((u16)0x0007)

#define VarPutBack_B_Position       ((u16)0x003C)
void PutBackPaint_B(void)
{
  char Str[64];
  u16 TempU16;

  LcdShowData16(VarPutBack_B_Position, 2);

  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", CurChgRecd_B.CardNum[0],CurChgRecd_B.CardNum[1],
            CurChgRecd_B.CardNum[2], CurChgRecd_B.CardNum[3], CurChgRecd_B.CardNum[4], CurChgRecd_B.CardNum[5],
            CurChgRecd_B.CardNum[6], CurChgRecd_B.CardNum[7], CurChgRecd_B.CardNum[8], CurChgRecd_B.CardNum[9]);
  LcdShowStr(TextPutBack_B_CardNum, (u8*)&Str[0], 20);

  TempU16 = CurChgRecd_B.ChgTime/60;//GetChgMin();
  LcdShowData16(DataPutBack_B_ChgMin, TempU16);
  TempU16 = CurChgRecd_B.ChgEnergy/10;
  LcdShowData16(DataPutBack_B_ChgEnergy, TempU16);
  TempU16 = BcsMsg_B.CurSoc;
  LcdShowData16(DataPutBack_B_Soc, TempU16);

  LcdShowData16(DataPutBack_B_EmployMoney, CurChgRecd_B.EmployMoney);
  LcdShowData16(DataPutBack_B_EnergyMoney, CurChgRecd_B.EnergyMoney);
  LcdShowData16(DataPutBack_B_ServeMoney, CurChgRecd_B.ServeMoney);
  LcdShowData16(DataPutBack_B_TotalMoney, CurChgRecd_B.TotalMoney);

  LcdShowNum(DataPutBack_B_Counter, 25);
  LcdShowPage(ScrnPutBack_B);
}

void PutBackIdle_B(void)
{

}

#define UnCnnctTime   (2*1000)//2

void LcdProPutBack_B(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  u8 Time = 0;

  ChargeEnable_B = 0;
  ChargePauseFlag_B = 0;
  BuzzerRun(1, 800, 100);

  LockSet_B(eSwSta_Off);
  CurChgRecd_B.ChgStopNotetrl = 1;
  osDelay(500);
  CurChgRecd_B.ChgRecUpCtrl = 1;

  TimeOutTick = 155;//31*100ms = 180;
  Time = 25;
  PutBackPaint_B();

  while(1)
  {
    if(TimeOutTick > 0)
      TimeOutTick--;

    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnPutBack_B_Cancle:    //"·ذ"
//                pLcdCtrl->CurScreen = eLcdPro_MainMenu;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnPutBack_B);
                break;
            }
          }
          else
            LcdShowPage(ScrnPutBack_B);
          break;

        default:
          break;
      }
    }

    if((TimeOutTick) < 1)
    {
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }
    else if(TimeOutTick < 100)
    {
      if(0 == PillarError_B.Value.EleLock)
      {
        if(0 == CurChgRecd_B.RecordValid)
        {
          pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
          pLcdCtrl->Param = 0;
        }
      }
      else
      {
        LcdShowPage(18);
        LcdShowData16(VarPutBack_B_Position, 2);
      }
    }

    if(eLcdPro_B_PutBack != pLcdCtrl->CurScreen)
      return;

    Temp = TimeOutTick/10;
    if(Time != Temp)
    {
      Time = Temp;
      LcdShowNum(DataPutBack_B_Counter, Time);
    }

    PutBackIdle_B();

    osDelay(100);
  }
}



