
/******************************************************************************
ļ  : LcdPro_GetCard.c
  : Һʾ棬Aǹˢ
  :
޸  : 2015-04-10      

******************************************************************************/

#include "Thd_Lcd.h"


#define ScrnGetCard      ((u16)3) //Aǹˢ

#define BtnGetCard_Cancle     ((u16)0x0301)

#define TextGetCard_Tip       ((u16)0x4000)

#define VarGetCard_Position   ((u16)0x003C)

void GetCardPaint(void)
{
  char Str[64] = {0};
  LcdShowData16(VarGetCard_Position, UserParam.ChgFun.Value.Num_B);
  snprintf(Str, sizeof(Str), "ˢ");
  LcdShowStr(TextGetCard_Tip, (u8*)Str, strlen(Str)+1);

  LcdShowPage(ScrnGetCard);
}

void GetCardIdle(void)
{

}

#define GetCardTime   (2*1000)
#define TimeOutTime   (40*1000)

void LcdProGetCard(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  EnumCardError CardRtn;
  u32 GetCardTick;
  u32 TimeOutTick;

  char Str[64] = {0};

  memset(&CardData, 0, sizeof(CardData));

  GetCardTick = 0;
  TimeOutTick = GetSystemTick();
  GetCardPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnGetCard_Cancle:  //"" 
                TimeOutTick = GetSystemTick();
//                pLcdCtrl->CurScreen = eLcdPro_MainMenu;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnGetCard);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if((GetSystemTick() - GetCardTick) > GetCardTime)
    {
      CardRtn = ReaderGetCard(&CardData);
      switch(CardRtn)
      {
        case eCardErr_CheckId_0:
        case eCardErr_ReadCardNum:
        case eCardErr_CheckId_1:
        case eCardErr_ReadValue:
        case eCardErr_ValueDec:
        case eCardErr_CheckId_2:
          GetCardTick = GetSystemTick();
          TimeOutTick = GetSystemTick();
          snprintf(Str, sizeof(Str), "ˢʧܣԡ");
          LcdShowStr(TextGetCard_Tip, (u8*)Str, strlen(Str)+1);
          BuzzerRun(2, 80, 80);
          break;
        case eCardErr_Ok:
          GetCardTick = GetSystemTick();
          TimeOutTick = GetSystemTick();

          if(TRUE == CarNumVerify(CardData.CardNum))
          {
            if((0x88 == CardData.CardNum[0]) && (0x80 == (CardData.CardNum[1] & 0x80)))
            {
              if((0xAA == CardData.CardStatus) && (0 != UserParam.LockCard))
              {
                snprintf(Str, sizeof(Str), "");
                LcdShowStr(TextGetCard_Tip, (u8*)Str, strlen(Str)+1);
                BuzzerRun(2, 80, 80);
              }
              else if(CardData.CardMoney <= 0)
              {
                snprintf(Str, sizeof(Str), "˻%.2fԪ,㡣", ((float)CardData.CardMoney/100));
                LcdShowStr(TextGetCard_Tip, (u8*)Str, strlen(Str)+1);
                BuzzerRun(2, 80, 80);
              }
              else
              {
                BuzzerRun(1, 80, 80);
                pLcdCtrl->CurScreen = eLcdPro_CardPwd;
                pLcdCtrl->Param = 0;
              }
            }
            else
            {//ֽ
              if(0 == UserParam.HadSigned)
              {//δ
                snprintf(Str, sizeof(Str), "ֽ𿨡");
                LcdShowStr(TextGetCard_Tip, (u8*)Str, strlen(Str)+1);
                BuzzerRun(2, 80, 80);
              }
              else
              {
                BuzzerRun(1, 80, 80);
                pLcdCtrl->CurScreen = eLcdPro_CardPwd;
                pLcdCtrl->Param = 0;
              }
            }
          }
          else
          {
            snprintf(Str, sizeof(Str), "ˢʧܣԡ");
            LcdShowStr(TextGetCard_Tip, (u8*)Str, strlen(Str)+1);
            BuzzerRun(2, 80, 80);
          }
          break;
        default:
          break;
      }
    }

    if(eLcdPro_GetCard != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      TimeOutTick = GetSystemTick();
//      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }

    GetCardIdle();

    osDelay(100);
  }
}


