
#include "Thd_Lcd.h"
#include "Thd_InternetBsb.h"


#define ScrnPutBack          ((u16)14)  //Aǹ  ״̬
#define ScrnElectLock        ((u16)18)
#define VarChargeScreen_Position           ((u16)0x003C)


#define BtnPutBack_Cancle     ((u16)0x0019)
#define DataPutBack_Counter   ((u16)0x0003)

#define TextPutBack_CardNum       ((u16)0x4020)

#define DataPutBack_ChgMin        ((u16)0x0006)
#define DataPutBack_ChgEnergy     ((u16)0x0005)
#define DataPutBack_Soc           ((u16)0x0023)

#define DataPutBack_EmployMoney   ((u16)0x002F)
#define DataPutBack_EnergyMoney   ((u16)0x000F)
#define DataPutBack_ServeMoney    ((u16)0x0010)
#define DataPutBack_TotalMoney    ((u16)0x0007)

#define VarPutBack_Position       ((u16)0x003C)
void PutBackPaint(void)
{
  char Str[64];
  u16 TempU16;

  LcdShowData16(VarPutBack_Position, UserParam.ChgFun.Value.Num_B);

  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", CurChgRecd.CardNum[0],CurChgRecd.CardNum[1],
            CurChgRecd.CardNum[2], CurChgRecd.CardNum[3], CurChgRecd.CardNum[4], CurChgRecd.CardNum[5],
            CurChgRecd.CardNum[6], CurChgRecd.CardNum[7], CurChgRecd.CardNum[8], CurChgRecd.CardNum[9]);
  LcdShowStr(TextPutBack_CardNum, (u8*)&Str[0], 20);

  TempU16 = CurChgRecd.ChgTime/60;//GetChgMin();
  LcdShowData16(DataPutBack_ChgMin, TempU16);
  TempU16 = CurChgRecd.ChgEnergy/10;
  LcdShowData16(DataPutBack_ChgEnergy, TempU16);
  TempU16 = BcsMsg.CurSoc;
  LcdShowData16(DataPutBack_Soc, TempU16);

  LcdShowData16(DataPutBack_EmployMoney, CurChgRecd.EmployMoney);
  LcdShowData16(DataPutBack_EnergyMoney, CurChgRecd.EnergyMoney);
  LcdShowData16(DataPutBack_ServeMoney, CurChgRecd.ServeMoney);
  LcdShowData16(DataPutBack_TotalMoney, CurChgRecd.TotalMoney);

  LcdShowNum(DataPutBack_Counter, 25);
  LcdShowPage(ScrnPutBack);
}

void PutBackIdle(void)
{

}

#define UnCnnctTime   (2*1000)//2

void LcdProPutBack(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  u8 Time = 0;

  ChargeEnable = 0;
  ChargePauseFlag = 0;
  BuzzerRun(1, 800, 100);

  LockSet(eSwSta_Off);
  CurChgRecd.ChgStopNotetrl = 1;
  osDelay(500);
  CurChgRecd.ChgRecUpCtrl = 1;

  TimeOutTick = 155;//31*100ms = 180;
  Time = 25;
  PutBackPaint();

  while(1)
  {
    if(TimeOutTick > 0)
      TimeOutTick--;

    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnPutBack_Cancle:    //"·ذ"
//                pLcdCtrl->CurScreen = eLcdPro_MainMenu;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnPutBack);
                break;
            }
          }
          else
            LcdShowPage(ScrnPutBack);
          break;

        default:
          break;
      }
    }

    if((TimeOutTick) < 1)
    {
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }
    else if(TimeOutTick < 100)
    {
      if(0 == PillarError.Value.EleLock)
      {
        if(0 == CurChgRecd.RecordValid)
        {
          pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
          pLcdCtrl->Param = 0;
        }
      }
      else
      {
        LcdShowPage(18);//ҳл
        LcdShowData16(VarChargeScreen_Position, UserParam.ChgFun.Value.Num_B);//ʶл
      }
    }

    if(eLcdPro_PutBack != pLcdCtrl->CurScreen)
      return;

    Temp = TimeOutTick/10;
    if(Time != Temp)
    {
      Time = Temp;
      LcdShowNum(DataPutBack_Counter, Time);
    }

    PutBackIdle();

    osDelay(100);
  }
}



