
/******************************************************************************
ļ  : Thd_InternetPotevio.c
  : Ʋ
  :
޸  : 2015-03-25      

******************************************************************************/

#include "Thd_InternetBsb.h"

#include "Drv_BoardIo.h"
//#include "Lcd_Common.h"
#include "Memory.h"
//#include "Drv_Led.h"

//#include "Drv_SpiFlash.h"
#include "Thd_Lcd.h"

#include "Thd_Charge.h"
#include "Thd_Charge_B.h"

#include "Drv_Adc.h"

#include "FTP_Upgrade.h"
//#include "Drv_RtcExt.h"

extern void NetLedOn(void);
extern void NetLedOff(void);

void SetServerIp(void)
{
  NetClose();
}

StructCommuStatus CommuStatus =
{
  0,0
};

void TempRecdSave(void)
{
#if 0
  if(TRUE == GetMemory(eeAddr_TempChgRecd, (u8*)&TempChgRecd, sizeof(TempChgRecd)))
  {
    if(1 == TempChgRecd.RecordValid)
    {
      if(0 == TempChgRecd.ChgStopType)
        TempChgRecd.ChgStopType = 2;//2	ϵֹ	ϵͳͻȻϵ磬ֹͣ

      if(HadSigned)
        TempRecdSaveToAwaitLog(&TempChgRecd);
//      else
      TempRecdSaveToLog(&TempChgRecd);
      TempChgRecd.RecordValid = 0;
      SaveMemory(eeAddr_TempChgRecd, (u8*)&TempChgRecd, sizeof(TempChgRecd));
    }
  }
#endif
}

void PillarSetTime(u8 *pFrame)
{
  StructTime TimeBlock;

  TimeBlock.Year = ((pFrame[0]>>4)&0x0F)*1000 + (pFrame[0]&0x0F)*100 + ((pFrame[1]>>4)&0x0F)*10 + (pFrame[1]&0x0F);
  TimeBlock.Mon = ((pFrame[2]>>4)&0x0F)*10 + (pFrame[2]&0x0F);
  TimeBlock.Day = ((pFrame[3]>>4)&0x0F)*10 + (pFrame[3]&0x0F);
  TimeBlock.Hour = ((pFrame[4]>>4)&0x0F)*10 + (pFrame[4]&0x0F);
  TimeBlock.Min = ((pFrame[5]>>4)&0x0F)*10 + (pFrame[5]&0x0F);
  TimeBlock.Sec = ((pFrame[6]>>4)&0x0F)*10 + (pFrame[6]&0x0F);
  //RtcExtSetTime(&TimeBlock);
  RtcSetTime(TimeToStamp(&TimeBlock));//DateTimeSet(TimeToStamp(&TimeBlock));
  RtcExtSetTime(&TimeBlock);
  LcdSetRtc(&TimeBlock);
}

u8 ResetFlag = 0;
u8  WaitChgRecdSendFlag = 0; //0Ҫͣ1Ҫͣ2ѷ 3ͳɹ

u8 AllowRemoteStartCharge(void)
{
  //if(eCnctSta_UnConnect == ConnectStatus)
  //  return FALSE;
  //if(eCnctSta_ConnectError == ConnectStatus)
  //  return FALSE;
  if((1 == CurChgRecd.RecordValid) || ((NULL != pCurChgRecd_AB) && (1 == pCurChgRecd_AB->RecordValid)))
    return FALSE;
  if(0 != PillarError.Mult)
    return FALSE;
  if(0 == UserParam.ChgFun.Value.Num_A)
    return FALSE;

  if((eLcdPro_MainMenu == LcdCtrl.CurScreen)
    || (eLcdPro_B_ChargeSummary == LcdCtrl.CurScreen)
    || (eLcdPro_GetCard == LcdCtrl.CurScreen)
    )
    return TRUE;
//  if(eScrn_CardUnavail == MenuParam.CurScreen)
//    return TRUE;
//  if(eScrn_ChargeAccount == MenuParam.CurScreen)
//    return TRUE;
  if(eLcdPro_ChgReserve == LcdCtrl.CurScreen)
    return TRUE;

  return FALSE;
}
u8 AllowRemoteStartCharge_B(void)
{
  if((1 == CurChgRecd_B.RecordValid) || ((NULL != pCurChgRecd_AB) &&(1 == pCurChgRecd_AB->RecordValid)))
    return FALSE;
  if(0 != PillarError_B.Mult)
    return FALSE;
  if(0 == UserParam.ChgFun.Value.Num_B)
    return FALSE;
  if((eLcdPro_MainMenu == LcdCtrl.CurScreen)
    || (eLcdPro_ChargeSummary == LcdCtrl.CurScreen)
    || (eLcdPro_B_GetCard == LcdCtrl.CurScreen)
    )
    return TRUE;

  return FALSE;
}

u8 AllowReverseCharge(void)
{
  if(1 == CurChgRecd.RecordValid)
    return FALSE;
  if(0 != PillarError.Mult)
    return FALSE;

  if(eLcdPro_MainMenu == LcdCtrl.CurScreen)
    return TRUE;
//  if(eScrn_CardUnavail == MenuParam.CurScreen)
//    return TRUE;
//  if(eScrn_ChargeAccount == MenuParam.CurScreen)
//    return TRUE;
  if(eLcdPro_ChgReserve == LcdCtrl.CurScreen)
    return TRUE;

  return FALSE;
}

void NetRecvProcess(void)
{
  u8 Frame[320];
  u8 Cmd;
//  StructTime Time;
  u32 Resp;

  if(TRUE == InternetFrameRecv(Frame))
  {
    Cmd = Frame[17];
    switch(Cmd)
    {
//׮ն˲
      case eCmd_sAckPillarSignIn:
        if((0x00 == Frame[3]) && (0x00 == Frame[4]) && (0x00 == Frame[5]) && (0x00 == Frame[6]))
        {
          memcpy( UserParam.PillarNum, &Frame[29], 8);
          //SaveMemory(eeAddr_PillarNum, UserParam.PillarNum, sizeof(UserParam.PillarNum));
          UserParam.HadSigned = 1;
          //SaveMemory(eeAddr_HadSigned, (u8*)&UserParam.HadSigned, sizeof(UserParam.HadSigned));

          SaveUserParam((u8*)&UserParam, sizeof(UserParam));
          UserParamInit();

          CommuStatus.ConnectFlag = 0;

          ResetFlag = 1;
        }
        else if((0x01 == Frame[3]) && (0x00 == Frame[4]) && (0x00 == Frame[5]) && (0x00 == Frame[6]))
        {
          if(0x02 == Frame[26])
          {
            CommuStatus.HeartBeatErrCnt_B = 0;
          }
          else
          {
            CommuStatus.HeartBeatErrCnt = 0;
          }
          CommuStatus.SignInRecvTime = GetSystemTick();
          CommuStatus.ConnectFlag = 1;
          //CommuStatus.HeartBeatErrCnt = 0;
        }
        else if((0x00 != Frame[4]) || (0x00 != Frame[5]) || (0x00 != Frame[6]))
        {
          NetClose();
          osDelay(300);
        }
        break;

      case eCmd_sReqTimeSyn:
        //if((1 == CurChgRecd.RecordValid) || (1 == ReserveParam.ValidFlag) || (1 == CurChgRecd_B.RecordValid))
        if(1 == ReserveParam.ValidFlag)
          Resp = 0xFF0201;
        else
        {
          Resp = 0x000000;
          PillarSetTime(&(Frame[27]));
          osDelay(100);
        }
        AckPillarTimeSet(Frame, Resp);
       // CommuStatus.ConnectFlag = 1;
        CommuStatus.HeartBeatErrCnt = 0;
		    CommuStatus.HeartBeatErrCnt_B = 0;
        break;

      case eCmd_sAckHeartBeat:
        if(0x02 == Frame[26])
        {
          CommuStatus.HeartBeatErrCnt_B = 0;
          CommuStatus.HeartBeatRecvTime_B = GetSystemTick();
        }
        else
        {
          CommuStatus.HeartBeatErrCnt = 0;
          CommuStatus.HeartBeatRecvTime = GetSystemTick();
        }
        CommuStatus.ConnectFlag = 1;
        break;

      case eCmd_sReqStartTransaction:
        if(0x02 == Frame[26])
        {
          if(FALSE == AllowRemoteStartCharge_B())
            Resp = 0xFF0201;
          else
          {
            if(ReserveParam_B.ValidFlag)
            {
              ReserveParam_B.ValidFlag = 0;
              //SendCancelReserve();
              osDelay(200);
            }
            Resp = 0x000000;
		    memset(&CurChgRecd_B, 0, sizeof(CurChgRecd_B));
            memcpy(CurChgRecd_B.CardNum, &Frame[37], 10);
            memcpy(CurChgRecd_B.OrderId, &Frame[51], 7);
            CurChgRecd_B.CardResp = 0;
            CurChgRecd_B.CardValidFlag = 0;//ˢ
            CurChgRecd_B.CardRespMoney = Frame[47];
            CurChgRecd_B.CardRespMoney |= ((u32)Frame[48]<<8);
            CurChgRecd_B.CardRespMoney |= ((u32)Frame[49]<<16);
            CurChgRecd_B.CardRespMoney |= ((u32)Frame[50]<<24);
            CurChgRecd_B.StartCardMoney = CurChgRecd_B.CardRespMoney;
            CurChgRecd_B.StopCardMoney = 0;//CurChgRecd_B.CardRespMoney;

          LcdCtrl.CurScreen = eLcdPro_B_CnctDetect;
          LcdCtrl.Param = 0;
          }
          CommuStatus.HeartBeatErrCnt_B = 0;
        }
        else
        {
        if(FALSE == AllowRemoteStartCharge())
          Resp = 0xFF0201;
        else
        {
          if(ReserveParam.ValidFlag)
          {
            ReserveParam.ValidFlag = 0;
            //SendCancelReserve();
            osDelay(200);
          }
          Resp = 0x000000;

          memset(&CurChgRecd, 0, sizeof(CurChgRecd));
          memcpy(CurChgRecd.CardNum, &Frame[37], 10);
          memcpy(CurChgRecd.OrderId, &Frame[51], 7);
          CurChgRecd.CardResp = 0;
          CurChgRecd.CardValidFlag = 0;//ˢ
          CurChgRecd.CardRespMoney = Frame[47];
          CurChgRecd.CardRespMoney |= ((u32)Frame[48]<<8);
          CurChgRecd.CardRespMoney |= ((u32)Frame[49]<<16);
          CurChgRecd.CardRespMoney |= ((u32)Frame[50]<<24);
          CurChgRecd.StartCardMoney = CurChgRecd.CardRespMoney;
          CurChgRecd.StopCardMoney = 0;

          LcdCtrl.CurScreen = eLcdPro_CnctDetect;
          LcdCtrl.Param = 0;
          }
          CommuStatus.HeartBeatErrCnt = 0;
        }
        AckStartTransaction(Frame, Resp);
        CommuStatus.ConnectFlag = 1;
        //CommuStatus.HeartBeatErrCnt = 0;
        break;

      case eCmd_sReqStopTransaction:
        if(0x02 == Frame[26])
        {
          if(0 == CurChgRecd_B.RecordValid)
            Resp = 0xFF0201;
          else
          {
            Resp = 0x000000;

          ChargePauseFlag_B = 1;
          osDelay(1500);


            memcpy(CurChgRecd_B.OrderId, &Frame[39], 7);

            //ChargeStopValueUpData();

            CurChgRecd_B.ChgStopType = 2;//Զ̽
            //CurChgRecd.ChgStopNotetrl = 1;//ϴ֪ͨ

          LcdCtrl.CurScreen = GetLcdProcess(eLcdPro_B_PutBack);
          LcdCtrl.Param = 0;
          }
          CommuStatus.HeartBeatErrCnt_B= 0;
        }
        else
        {
        if(0 == CurChgRecd.RecordValid)
          Resp = 0xFF0201;
        else
        {
          Resp = 0x000000;

          ChargePauseFlag = 1;
          osDelay(1500);

          memcpy(CurChgRecd.OrderId, &Frame[39], 7);

          CurChgRecd.ChgStopType = 2;//Զֹͣ	ͨƽ̨ϵͳ´ָͣֹͣ	2

          //LcdCtrl.CurScreen = eLcdPro_PutBack;
          LcdCtrl.CurScreen = GetLcdProcess(eLcdPro_PutBack);
          LcdCtrl.Param = 0;
          }
          CommuStatus.HeartBeatErrCnt = 0;
        }
        AckStopTransaction(Frame, Resp);
        CommuStatus.ConnectFlag = 1;
        //CommuStatus.HeartBeatErrCnt = 0;
        osDelay(200);
        break;

      case eCmd_sReqReserveNow:
        if((FALSE == AllowReverseCharge()) || (0 != UserParam.ChgFun.Value.Num_B))
        //if(1)
          Resp = 0xFF0201;
        else
        {
          Resp = 0x000000;
          ReserveParam.ValidFlag = 1;
          memcpy(ReserveParam.CardNum, &Frame[28], 10);
          ReserveParam.StopTime = RtcGetTime() + Frame[38]*60;//6Сʱ
          LcdCtrl.CurScreen = eLcdPro_ChgReserve;
          LcdCtrl.Param = 0;
        }
        AckReserveNow(Frame, Resp);
        CommuStatus.ConnectFlag = 1;
        CommuStatus.HeartBeatErrCnt = 0;
        CommuStatus.HeartBeatErrCnt_B = 0;
        break;

      case eCmd_sReqCancelReserve:
        Resp = 0x000000;
        if(0x02 == Frame[26])
        {
          ReserveParam_B.ValidFlag = 0;
          CommuStatus.HeartBeatErrCnt_B = 0;
        }
        else
        {
          ReserveParam.ValidFlag = 0;
          CommuStatus.HeartBeatErrCnt = 0;
        }
        AckCancelReserve(Frame, Resp);
        CommuStatus.ConnectFlag = 1;
        //CommuStatus.HeartBeatErrCnt = 0;
        break;

      case eCmd_sAckCardSure:
        if(0x02 == Frame[26])
        {
          CurChgRecd_B.CardResp = Frame[38];
          CurChgRecd_B.CardRespMoney = Frame[39];
          CurChgRecd_B.CardRespMoney |= ((u32)Frame[40]<<8);
          CurChgRecd_B.CardRespMoney |= ((u32)Frame[41]<<16);
          CurChgRecd_B.CardRespMoney |= ((u32)Frame[42]<<24);
          CurChgRecd_B.CardSureCtrl = 3;
          CommuStatus.HeartBeatErrCnt_B = 0;
        }
        else
        {
        CurChgRecd.CardResp = Frame[38];
        CurChgRecd.CardRespMoney = Frame[39];
        CurChgRecd.CardRespMoney |= ((u32)Frame[40]<<8);
        CurChgRecd.CardRespMoney |= ((u32)Frame[41]<<16);
        CurChgRecd.CardRespMoney |= ((u32)Frame[42]<<24);
        CurChgRecd.CardSureCtrl = 3;
          CommuStatus.HeartBeatErrCnt = 0;
        }
        CommuStatus.ConnectFlag = 1;
        //CommuStatus.HeartBeatErrCnt = 0;
        break;

      case eCmd_sAckChgRecord:
        if(0x02 == Frame[26])
        {
          if(2 == CurChgRecd_B.ChgRecUpCtrl)
          {
            CurChgRecd_B.ChgRecUpCtrl = 3;
          }
          CommuStatus.HeartBeatErrCnt_B= 0;
        }
        else
        {
        if(2 == CurChgRecd.ChgRecUpCtrl)
          {
          CurChgRecd.ChgRecUpCtrl = 3;
          }
          CommuStatus.HeartBeatErrCnt = 0;
        }
        CommuStatus.ConnectFlag = 1;
        //CommuStatus.HeartBeatErrCnt = 0;
        break;

      case eCmd_sAckAwaitChgRecd:
        if(2 == WaitChgRecdSendFlag)
        {
          WaitChgRecdSendFlag = 3;
        }
        CommuStatus.ConnectFlag = 1;
        CommuStatus.HeartBeatErrCnt = 0;
        CommuStatus.HeartBeatErrCnt_B= 0;
        break;

      case eCmd_sReqSetQrcode:
        memcpy(UserParam.PillarNum, &Frame[27], 8);
        //SaveMemory(eeAddr_PillarNum, (u8*)&UserParam.PillarNum, sizeof(UserParam.PillarNum));

        SaveUserParam((u8*)&UserParam, sizeof(UserParam));
        UserParamInit();

        AckSetQrcode(Frame);

        CommuStatus.ConnectFlag = 1;
        CommuStatus.HeartBeatErrCnt = 0;
        CommuStatus.HeartBeatErrCnt_B= 0;
        NetClose();
        break;

      case eCmd_sReqPillarReset:
        if(CurChgRecd.RecordValid)
        {
          CurChgRecd.ChgStopType = 7;//Զֹͣ	Զ׮ֹͣ	7

          LcdCtrl.CurScreen = GetLcdProcess(eLcdPro_PutBack);
          LcdCtrl.Param = 0;

          osDelay(30000);
        }
        if(CurChgRecd_B.RecordValid)
        {
          CurChgRecd_B.ChgStopType = 7;//Զ̽
          LcdCtrl.CurScreen = GetLcdProcess(eLcdPro_B_PutBack);
          LcdCtrl.Param = 0;
        }
        AckPillarReset(Frame);
        ResetFlag = 1;
        CommuStatus.ConnectFlag = 1;
        CommuStatus.HeartBeatErrCnt = 0;
        CommuStatus.HeartBeatErrCnt_B = 0;

        break;
      case eCmd_sReqGetServerIp:
        AckGetServerIp(Frame);
        CommuStatus.ConnectFlag = 1;
        CommuStatus.HeartBeatErrCnt = 0;
        CommuStatus.HeartBeatErrCnt_B = 0;
        break;

      case eCmd_sReqSetServerIp:
        if(Frame[27])
        {
        #if 0
          Resp = 0x000000;

          IpSetDelay.IpAddr.Ip[0] = Frame[35];
          IpSetDelay.IpAddr.Ip[1] = Frame[36];
          IpSetDelay.IpAddr.Ip[2] = Frame[37];
          IpSetDelay.IpAddr.Ip[3] = Frame[38];
          IpSetDelay.IpAddr.Port = (u16)Frame[39] + (u16)Frame[40]*256;

          Time.Year = (Frame[28]>>4)*1000 + (Frame[28]&0x0F)*100 + (Frame[29]>>4)*10 + (Frame[29]&0x0F);
          Time.Mon = (Frame[30]>>4)*10 + (Frame[30]&0x0F);
          Time.Day = (Frame[31]>>4)*10 + (Frame[31]&0x0F);
          Time.Hour = (Frame[32]>>4)*10 + (Frame[32]&0x0F);
          Time.Min = (Frame[33]>>4)*10 + (Frame[33]&0x0F);
          Time.Sec = (Frame[34]>>4)*10 + (Frame[34]&0x0F);
          IpSetDelay.SetTime = TimeToStamp(&Time);
          IpSetDelay.SetFlag = 1;
          SaveMemory(eeAddr_IpSetDelay, (u8*)&IpSetDelay, sizeof(IpSetDelay));
        #endif
          Resp = 0xFF0201;
        }
        else
        {
          Resp = 0x000000;

          UserParam.ServerAddr.Ip[0] = Frame[35];
          UserParam.ServerAddr.Ip[1] = Frame[36];
          UserParam.ServerAddr.Ip[2] = Frame[37];
          UserParam.ServerAddr.Ip[3] = Frame[38];
          UserParam.ServerAddr.Port = (u16)Frame[39] + (u16)Frame[40]*256;
          //SaveMemory(eeAddr_ServerAddr, (u8*)&UserParam.ServerAddr, sizeof(SUserParam.erverAddr));

          SaveUserParam((u8*)&UserParam, sizeof(UserParam));
          UserParamInit();

          ResetFlag = 1;
        }
        AckSetServerIp(Frame, Resp);
        CommuStatus.ConnectFlag = 1;
        CommuStatus.HeartBeatErrCnt = 0;
        CommuStatus.HeartBeatErrCnt_B = 0;
        break;

      case eCmd_sReqGetRate:
        AckGetRate(Frame);
        CommuStatus.ConnectFlag = 1;
        CommuStatus.HeartBeatErrCnt = 0;
        CommuStatus.HeartBeatErrCnt_B= 0;
        break;
      case eCmd_sReqSetRate:
        Resp = 0x000000;
        UserParam.EnergyRate[0] = (u16)Frame[27] + (u16)Frame[28]*256;
        UserParam.EnergyRate[1] = (u16)Frame[29] + (u16)Frame[30]*256;
        UserParam.EnergyRate[2] = (u16)Frame[31] + (u16)Frame[32]*256;
        UserParam.EnergyRate[3] = (u16)Frame[33] + (u16)Frame[34]*256;
        //SaveMemory(eeAddr_EnergyRate, (u8*)&UserParam.EnergyRate, sizeof(UserParam.EnergyRate));
        UserParam.ServerRate2[0] = (u16)Frame[35] + (u16)Frame[36]*256;
        //SaveMemory(eeAddr_ServerRate, (u8*)&UserParam.ServerRate, sizeof(UserParam.ServerRate));
        memcpy(UserParam.EnergyTimeRate, &Frame[37], sizeof(UserParam.EnergyTimeRate));
        //SaveMemory(eeAddr_EnergyTimeRate, (u8*)&UserParam.EnergyTimeRate, sizeof(UserParam.EnergyTimeRate));

        UserParam.FreeTime = (u16)Frame[85] + (u16)Frame[86]*256;
        UserParam.EmployRate = (u16)Frame[87] + (u16)Frame[88]*256;

        SaveUserParam((u8*)&UserParam, sizeof(UserParam));
        UserParamInit();

        AckSetRate(Frame, Resp);

        CommuStatus.ConnectFlag = 1;
        CommuStatus.HeartBeatErrCnt = 0;
        CommuStatus.HeartBeatErrCnt_B = 0;
        break;

      case eCmd_sAckStartTransaction:
      case eCmd_sAckStopTransaction:
      case eCmd_sAckCancelReserve:
      //case eCmd_sAckPillarSignOut:
        CommuStatus.ConnectFlag = 1;
        CommuStatus.HeartBeatErrCnt = 0;
        CommuStatus.HeartBeatErrCnt_B = 0;
        break;
      case eCmd_cReqSetMoneyKey:
        Resp = 0x000000;
        memcpy(UserParam.MoneyKey, &Frame[27], 6);
        SaveUserParam((u8*)&UserParam, sizeof(UserParam));
        UserParamInit();

        AckSetMoneyKey(Frame, Resp);
        CommuStatus.ConnectFlag = 1;
        CommuStatus.HeartBeatErrCnt = 0;
        CommuStatus.HeartBeatErrCnt_B = 0;
        break;
      case eCmd_FtpUpgrade:
        memcpy(FtpInfo.UpgradeSvIp, Frame+10, 20);
        memcpy(FtpInfo.UpgradePort, Frame+30, 5);
        memcpy(FtpInfo.UserName, Frame+60, 20);
        memcpy(FtpInfo.UserPswd, Frame+80, 20);

        if(eSwSta_On != CcStatusRead())
        {
          FtpUpgradeAck(Frame,0);
          FtpStart();
        }
        else
        {
          FtpUpgradeAck(Frame,1);
        }
        break;
      default:
        //SendPillarSignIn(Frame);
        break;
    }
  }
}

typedef struct
{
  u8 HeartPeriod;//
  u8 HeartErrCntMax;//
  u8 HeartTimeout;//
  u16 SignInPeriod;//
}StructCommuParam;

const StructCommuParam CommuParam =
{
  .HeartPeriod = 10,
  .HeartErrCntMax = 3,
  .HeartTimeout = 6,
  .SignInPeriod = 60,
};//̨ͨŲ

void PillarSignIn(void)
{
  static u32 SignTick = 0;

  EnumSwitchStatus NetLink = eSwSta_Off;

  NetLink = (TRUE == NetAvail()) ? eSwSta_On : eSwSta_Off;
  if(eSwSta_Off == NetLink)
    CommuStatus.ConnectFlag = 0;//δͨ
#if 0
  if(0 == CommuStatus.ConnectFlag)
  {
    ChargeError |= eChgErr_NetConnect;
    ChargeError_B |= eChgErr_NetConnect;
  }
  else
  {
    ChargeError &= (~eChgErr_NetConnect);
    ChargeError_B &= (~eChgErr_NetConnect);
  }
#endif
  if(0 == UserParam.HadSigned)//ûע20sһ
  {
    if((0 == SignTick) && (eSwSta_On == NetLink))
    {
      SendPillarSignIn(0);
      SignTick = GetSystemTick();
    }
    else
    {
      if(((GetSystemTick() - SignTick) > (20*1000)) && (eSwSta_On == NetLink))
      {
        SendPillarSignIn(0);
        SignTick = GetSystemTick();
      }
    }
    return;
  }

  if(0 == CommuStatus.ConnectFlag)//δϷ20sһ
  {
    if((0 == SignTick) && (eSwSta_On == NetLink))
    {
      SendPillarSignIn(0);
      SignTick = GetSystemTick();
    }
    else
    {
      if(((GetSystemTick() - SignTick) > (20*1000)) && (eSwSta_On == NetLink))
      {
        SendPillarSignIn(0);
        SignTick = GetSystemTick();
      }
    }
    return;
  }

  if(0 == CommuStatus.SignInRecvTime)
  {
    if((GetSystemTick() - CommuStatus.SignInSendTime) > (20*1000))
    {
      SendPillarSignIn(0);
      CommuStatus.SignInSendTime = GetSystemTick();
      CommuStatus.SignInRecvTime = 0;
    }
  }
  else
  {
    if((GetSystemTick() - CommuStatus.SignInRecvTime) > (CommuParam.SignInPeriod*60*1000))
    {
      SendPillarSignIn(0);
      CommuStatus.SignInSendTime = GetSystemTick();
      CommuStatus.SignInRecvTime = 0;
    }
  }
}

void PillarStatus(void)
{
  static u8 LastPillarStatus = 0;
  static EnumSwitchStatus LastCcStatus = eSwSta_Off;
  static UnionPillarError LastPillarError = {.Mult = 0,};
  u32 Temp = 0;

  u8 SendFlag = 0;

  if(CurChgRecd.RecordValid)
    Temp = 1;
  else if(ReserveParam.ValidFlag)
    Temp = 2;
  else
    Temp = 0;
  if(Temp != LastPillarStatus)//ϢЧ
  {
    LastPillarStatus = (u8)Temp;
    SendFlag = 1;
  }

  if(LastCcStatus != CcStatusRead())//Ӹ
  {
    LastCcStatus = CcStatusRead();
    SendFlag = 2;
  }

  if(LastPillarError.Mult != PillarError.Mult)//
  {
    LastPillarError = PillarError;
    SendFlag = 2;
  }

  if(SendFlag && CommuStatus.ConnectFlag)//Ӹ·
  {
    SendHeartBeat(1);
    CommuStatus.HeartBeatSendTime = GetSystemTick();
    CommuStatus.HeartBeatRecvTime = 0;
  }

  SendFlag = 0;
  if(LastCcStatus != CcStatusRead())//Ӹ
  {
    LastCcStatus = CcStatusRead();
    SendFlag = 2;
  }
  if(SendFlag && CommuStatus.ConnectFlag)//Ӽ·ǹ״̬
    SendPillarStatus(1);
}
void PillarStatus_B(void)
{
  static u8 LastPillarStatus = 0;
  static EnumSwitchStatus LastCcStatus = eSwSta_Off;
  static UnionPillarError LastPillarError = {.Mult = 0,};

  u32 Temp = 0;

  u8 SendFlag = 0;

  if(CurChgRecd_B.RecordValid)
    Temp = 1;
//  else if(ReserveParam.ValidFlag)
//    Temp = 2;
  else
    Temp = 0;
  if(Temp != LastPillarStatus)//ϢЧ
  {
    LastPillarStatus = (u8)Temp;
    SendFlag = 1;
  }
  if(LastCcStatus != CcStatusRead_B())//Ӹ
  {
    LastCcStatus = CcStatusRead_B();
    SendFlag = 2;
  }

  if(LastPillarError.Mult != PillarError_B.Mult)//
  {
    LastPillarError = PillarError_B;
    SendFlag = 2;
  }


  if(SendFlag && CommuStatus.ConnectFlag)//Ӹ·
  {
    SendHeartBeat(2);
    CommuStatus.HeartBeatSendTime_B = GetSystemTick();
    CommuStatus.HeartBeatRecvTime_B = 0;

  }
  SendFlag = 0;
  if(LastCcStatus != CcStatusRead_B())//Ӹ
  {
    LastCcStatus = CcStatusRead_B();
    SendFlag = 2;
  }
  if(SendFlag && CommuStatus.ConnectFlag)//Ӽ·ǹ״̬
    SendPillarStatus(2);
}

void PillarHeartBeat(void)
{
  u32 SendTick;

  if(0 == CommuStatus.ConnectFlag)
    return;

  if(0 == CommuStatus.HeartBeatRecvTime)//ʼ12sһ
  {
    if((GetSystemTick() - CommuStatus.HeartBeatSendTime) > ((u32)CommuParam.HeartTimeout*1000))
    {
      CommuStatus.HeartBeatErrCnt++;
      if(CommuStatus.HeartBeatErrCnt > CommuParam.HeartErrCntMax)
      {
        CommuStatus.ConnectFlag = 0;
        CommuStatus.HeartBeatErrCnt = 0;
        NetClose();
      }
      else
      {
        SendHeartBeat(1);
        CommuStatus.HeartBeatSendTime = GetSystemTick();
        CommuStatus.HeartBeatRecvTime = 0;
      }
    }
  }
  else
  {//
    if(CurChgRecd.RecordValid)
      SendTick = ((u32)CommuParam.HeartPeriod*1000)/2;
    else
      SendTick = ((u32)CommuParam.HeartPeriod*1000);

    if((GetSystemTick() - CommuStatus.HeartBeatSendTime) > SendTick)
    {
      SendHeartBeat(1);
      CommuStatus.HeartBeatSendTime = GetSystemTick();
      CommuStatus.HeartBeatRecvTime = 0;
	 // osDelay(1000);
	 //SendBatInfor(1);
    }
  }
}
void PillarHeartBeat_B(void)
{
  u32 SendTick;

  if(0 == CommuStatus.ConnectFlag)
    return;

  if(0 == CommuStatus.HeartBeatRecvTime_B)//ʼ12sһ
  {
    if((GetSystemTick() - CommuStatus.HeartBeatSendTime_B) > ((u32)CommuParam.HeartTimeout*1000))
    {
      CommuStatus.HeartBeatErrCnt_B++;
      if(CommuStatus.HeartBeatErrCnt_B> CommuParam.HeartErrCntMax)
      {
        CommuStatus.ConnectFlag = 0;
        CommuStatus.HeartBeatErrCnt_B = 0;
        NetClose();
      }
      else
      {
        SendHeartBeat(2);
        CommuStatus.HeartBeatSendTime_B = GetSystemTick();
        CommuStatus.HeartBeatRecvTime_B = 0;
      }
    }
  }
  else
  {//
    if(CurChgRecd_B.RecordValid)
      SendTick = ((u32)CommuParam.HeartPeriod*1000)/2;
    else
      SendTick = ((u32)CommuParam.HeartPeriod*1000);

    if((GetSystemTick() - CommuStatus.HeartBeatSendTime_B) > SendTick)
    {
      SendHeartBeat(2);
      CommuStatus.HeartBeatSendTime_B= GetSystemTick();
      CommuStatus.HeartBeatRecvTime_B= 0;
    }
  }
}

void NetLedShow(void)
{
  static u8 LastCommFlag = 0;
  static u32 ShowTick = 0;

  if(0 == ShowTick)
  {
    ShowTick = GetSystemTick();
    LastCommFlag = CommuStatus.ConnectFlag;
    if(1 == CommuStatus.ConnectFlag)
      NetLedOn();
    else
      NetLedOff();
  }
  else
  {
    if(((GetSystemTick() - ShowTick) > (60*1000)) || (LastCommFlag != CommuStatus.ConnectFlag))
    {
      ShowTick = GetSystemTick();
      LastCommFlag = CommuStatus.ConnectFlag;
      if(1 == CommuStatus.ConnectFlag)
        NetLedOn();
      else
        NetLedOff();
    }
  }
}

void ReserveNote(void)
{
  if(ReserveParam.ReserveNoteCtrl)
  {
    if(CommuStatus.ConnectFlag)
      SendCancelReserve(1);
    ReserveParam.ReserveNoteCtrl = 0;
  }
}

void NetLinkProcess(void)
{
  PillarSignIn();
  PillarStatus();
  PillarHeartBeat();

  if(0 != UserParam.ChgFun.Value.Num_B)
  {
    PillarStatus_B();
    PillarHeartBeat_B();
  }

  ReserveNote();
  NetLedShow();
}

void CardSure(void)
{
  static u32 CardSureSendTick = 0;
  static u32 CardSureSendErr = 0;

  if(1 == CurChgRecd.CardSureCtrl)
  {
    if(CommuStatus.ConnectFlag)
    {
      CurChgRecd.CardSureCtrl = 2;
      SendCardSure(1);
      CardSureSendTick = GetSystemTick();
      CardSureSendErr = 0;
    }
    /*else
      CurChgRecd.CardSureCtrl = 4;*/
  }

  if(2 == CurChgRecd.CardSureCtrl)
  {//7ط
    if((GetSystemTick() - CardSureSendTick) > (5*1000))
    {
      CardSureSendErr++;
      if(/*(CommuStatus.ConnectFlag) &&*/ (CardSureSendErr < 6))
      {//ʱС3  ط
        SendCardSure(1);
        CardSureSendTick = GetSystemTick();
      }
      else
      {
        CurChgRecd.CardSureCtrl = 4;
        CardSureSendErr = 0;
      }
    }
  }
}
void CardSure_B(void)
{
  static u32 CardSureSendTick = 0;
  static u32 CardSureSendErr = 0;

  if(1 == CurChgRecd_B.CardSureCtrl)
  {
    if(CommuStatus.ConnectFlag)
    {
      CurChgRecd_B.CardSureCtrl = 2;
      SendCardSure(2);
      CardSureSendTick = GetSystemTick();
      CardSureSendErr = 0;
    }
    /*else
      CurChgRecd_B.CardSureCtrl = 4;*/
  }

  if(2 == CurChgRecd_B.CardSureCtrl)
  {//7ط
    if((GetSystemTick() - CardSureSendTick) > (5*1000))
    {
      CardSureSendErr++;
      if(/*(CommuStatus.ConnectFlag) &&*/ (CardSureSendErr < 6))
      {//ʱС3  ط
        SendCardSure(2);
        CardSureSendTick = GetSystemTick();
      }
      else
      {
        CurChgRecd_B.CardSureCtrl = 4;
        CardSureSendErr = 0;
      }
    }
  }
}






StructAwaitChgRecdLog AwaitChgRecd;//ϴĴ¼

void AwaitChgRecdSend(void)
{
  static u16 CurWaitChgRecdSendNum = 0;
  static u32 WaitChgRecdSendTick = 0;

  if(CommuStatus.ConnectFlag)
  {
    if((0 != WaitUpChgRecdNum) && (0 == WaitChgRecdSendFlag))
    {
      AwaitChgRecdRead(CurWaitChgRecdSendNum, &AwaitChgRecd);
      if((0x5A == AwaitChgRecd.End) && (0xFF == AwaitChgRecd.SendFlag))
        WaitChgRecdSendFlag = 1;
      else
      {
        CurWaitChgRecdSendNum++;
        if(CurWaitChgRecdSendNum >= WaitUpChgRecdNum)
        {
          WaitUpChgRecdNum = 0;
          CurWaitChgRecdSendNum = 0;
          //SaveMemory(eeAddr_WaitUpChgRecdNum, (u8*)&WaitUpChgRecdNum, sizeof(WaitUpChgRecdNum));
        }
      }
    }

    if(1 == WaitChgRecdSendFlag)
    {
      SendAwaitChgRecd(&AwaitChgRecd);
      WaitChgRecdSendTick = GetSystemTick();
      WaitChgRecdSendFlag = 2;
    }
    else if(2 == WaitChgRecdSendFlag)
    {//ش޸Ϊʱȴ12
      if((GetSystemTick() - WaitChgRecdSendTick) > (16*1000))
      {
        SendAwaitChgRecd(&AwaitChgRecd);
        WaitChgRecdSendTick = GetSystemTick();
      }
    }
  }

  if(3 == WaitChgRecdSendFlag)
  {//ѽյظ
//    AwaitRecdSaveToLog(&AwaitChgRecd);
    AwaitChgRecd.SendFlag = 0x00;
    AwaitChgRecdWrite(CurWaitChgRecdSendNum, &AwaitChgRecd);

    CurWaitChgRecdSendNum++;
    if(CurWaitChgRecdSendNum == WaitUpChgRecdNum)
    {
      WaitUpChgRecdNum = 0;
      CurWaitChgRecdSendNum = 0;
      //SaveMemory(eeAddr_WaitUpChgRecdNum, (u8*)&WaitUpChgRecdNum, sizeof(WaitUpChgRecdNum));
    }
    WaitChgRecdSendFlag = 0;
  }
}

void CurChgRecord(void)
{
  static u32 ChgProcessRecdTick = 0;
  static u32 ChgRecordSendTick = 0;
  static u32 ChgRecordSendErr = 0;

//  if((0 != CurChgRecd.RecordValid) && (0 == CurChgRecd.ChgRecUpCtrl) && (0 != CurChgRecd.ChgStartTime))
//  {
//    if((GetSystemTick() - ChgProcessRecdTick) > (10*60*1000))//10
//    {
//      ChgProcessRecdTick = GetSystemTick();
//      ChgProcSaveToLog();
//    }
//  }

  if(((eChgPro_ChgRun == ChargeCtrl.CurProcess)
      || (eChgPro_WaitVoltChgRun == ChargeCtrl.CurProcess)
      || (eChgPro_AB_ChgRun == ChargeCtrl.CurProcess)
      || (eChgPro_AB_WaitVoltChgRun == ChargeCtrl.CurProcess)
      )
    && (0 != CurChgRecd.RecordValid)
    && (CommuStatus.ConnectFlag)
    )
  {
    if((GetSystemTick() - ChgProcessRecdTick) > (30*1000))//30s
    {
      ChgProcessRecdTick = GetSystemTick();
      //SendBatInfor(1);
    }
  }

  if(CurChgRecd.ChgStartNoteCtrl)
  {
    CurChgRecd.ChgStartNoteCtrl = 0;
    if(CommuStatus.ConnectFlag)
      SendStartTransaction(1);
  }
  else if(CurChgRecd.ChgStopNotetrl)
  {
    CurChgRecd.ChgStopNotetrl = 0;
    if(CommuStatus.ConnectFlag)
      SendStopTransaction(1);
  }
  else if((0 != CurChgRecd.RecordValid) && (1 == CurChgRecd.ChgRecUpCtrl))//¼Ҫϴ
  {//¼֡
    if(CommuStatus.ConnectFlag)
    {
      SendChgRecord(1);
      ChgRecordSendTick = GetSystemTick();
      CurChgRecd.ChgRecUpCtrl = 2;
      ChgRecordSendErr = 0;
    }
    else
    {//ʱڣ
      CurChgRecd.ChgRecUpCtrl = 4;
      ChgRecordSendErr = 0;
    }
  }

  if((0 != CurChgRecd.RecordValid) && (2 == CurChgRecd.ChgRecUpCtrl))
  {//6ط
    if((GetSystemTick() - ChgRecordSendTick) > (16*1000))
    {
      ChgRecordSendErr++;
      if((CommuStatus.ConnectFlag) && (ChgRecordSendErr < 1))
      {//ʱС3
        SendChgRecord(1);
        ChgRecordSendTick = GetSystemTick();
      }
      else
      {//ʱڣ
        CurChgRecd.ChgRecUpCtrl = 4;
        ChgRecordSendErr = 0;
      }
    }
  }

  if((0 != CurChgRecd.RecordValid) && (3 == CurChgRecd.ChgRecUpCtrl))
  {
    ChgRecdSaveToLog(&CurChgRecd, 1);
    TempChgRecdSaveToLog(&CurChgRecd, 1, 0);

    CurChgRecd.RecordValid = 0;
    memset(CurChgRecd.CardNum, 0, sizeof(CurChgRecd.CardNum));
  }

  if((0 != CurChgRecd.RecordValid) && (4 == CurChgRecd.ChgRecUpCtrl))
  {//Ҫ
    if(UserParam.HadSigned)
      ChgRecdSaveToAwaitLog(&CurChgRecd, 1);

    ChgRecdSaveToLog(&CurChgRecd, 1);
    TempChgRecdSaveToLog(&CurChgRecd, 1, 0);

    CurChgRecd.ChgRecUpCtrl = 5;

    CurChgRecd.RecordValid = 0;
    memset(CurChgRecd.CardNum, 0, sizeof(CurChgRecd.CardNum));
  }
}
void CurChgRecord_B(void)
{
  static u32 ChgProcessRecdTick = 0;
  static u32 ChgRecordSendTick = 0;
  static u32 ChgRecordSendErr = 0;

//  if((0 != CurChgRecd.RecordValid) && (0 == CurChgRecd.ChgRecUpCtrl) && (0 != CurChgRecd.ChgStartTime))
//  {
//    if((GetSystemTick() - ChgProcessRecdTick) > (10*60*1000))//10
//    {
//      ChgProcessRecdTick = GetSystemTick();
//      ChgProcSaveToLog();
//    }
//  }

  if(((eChgPro_B_ChgRun == ChargeCtrl_B.CurProcess) || (eChgPro_B_WaitVoltChgRun == ChargeCtrl_B.CurProcess))
    && (0 != CurChgRecd_B.RecordValid)
    && (CommuStatus.ConnectFlag)
    )
  {
    if((GetSystemTick() - ChgProcessRecdTick) > (30*1000))//30s
    {
      ChgProcessRecdTick = GetSystemTick();
     // SendBatInfor(2);
    }
  }


  if(CurChgRecd_B.ChgStartNoteCtrl)
  {
    CurChgRecd_B.ChgStartNoteCtrl = 0;
    if(CommuStatus.ConnectFlag)
      SendStartTransaction(2);
  }
  else if(CurChgRecd_B.ChgStopNotetrl)
  {
    CurChgRecd_B.ChgStopNotetrl = 0;
    if(CommuStatus.ConnectFlag)
      SendStopTransaction(2);
  }
  else if((0 != CurChgRecd_B.RecordValid) && (1 == CurChgRecd_B.ChgRecUpCtrl))//¼Ҫϴ
  {//¼֡
    if(CommuStatus.ConnectFlag)
    {
      SendChgRecord(2);
      ChgRecordSendTick = GetSystemTick();
      CurChgRecd_B.ChgRecUpCtrl = 2;
      ChgRecordSendErr = 0;
    }
    else
    {
      CurChgRecd_B.ChgRecUpCtrl = 4;
      ChgRecordSendErr = 0;
    }
  }

  if((0 != CurChgRecd_B.RecordValid) && (2 == CurChgRecd_B.ChgRecUpCtrl))
  {//6ط
    if((GetSystemTick() - ChgRecordSendTick) > (16*1000))
    {
      ChgRecordSendErr++;
      if((CommuStatus.ConnectFlag) && (ChgRecordSendErr < 1))
      {//ʱС3
        SendChgRecord(2);
        ChgRecordSendTick = GetSystemTick();
      }
      else
      {//ʱڣ
        CurChgRecd_B.ChgRecUpCtrl = 4;
        ChgRecordSendErr = 0;
      }
    }
  }

  if((0 != CurChgRecd_B.RecordValid) && (3 == CurChgRecd_B.ChgRecUpCtrl))
  {
    ChgRecdSaveToLog(&CurChgRecd_B, 2);
    TempChgRecdSaveToLog(&CurChgRecd_B, 2, 0);

    CurChgRecd_B.RecordValid = 0;
    memset(CurChgRecd_B.CardNum, 0, sizeof(CurChgRecd_B.CardNum));

  }



  if((0 != CurChgRecd_B.RecordValid) && (4 == CurChgRecd_B.ChgRecUpCtrl))
  {//Ҫ
    if(UserParam.HadSigned)
      ChgRecdSaveToAwaitLog(&CurChgRecd_B, 2);

    ChgRecdSaveToLog(&CurChgRecd_B, 2);
    TempChgRecdSaveToLog(&CurChgRecd_B, 2, 0);
    CurChgRecd_B.ChgRecUpCtrl = 5;
    CurChgRecd_B.RecordValid = 0;

    memset(CurChgRecd_B.CardNum, 0,sizeof(CurChgRecd_B.CardNum));
  }
}

void NetWorkProcess(void)
{
  CardSure();
  CurChgRecord();

  if(0 != UserParam.ChgFun.Value.Num_B)
  {
    CardSure_B();
    CurChgRecord_B();
  }

  AwaitChgRecdSend();
}

void AlarmCodeDone(void)
{

#if 0
  static EnumChargError LastChargeErr;
  u32 Temp;

  Temp = LastChargeErr ^ ChargeError;
  if(Temp)
  {//
    Temp = (u32)(ChargeError & Temp);//
    if(Temp & eChgErr_StopErr)
      AlarmSaveToLog(0x01, eChgErr_StopErr);//ϵͳ澯 0x01
    if(Temp & eChgErr_RelayErr)
      AlarmSaveToLog(0x01, eChgErr_RelayErr);//ϵͳ澯 0x01
    if(Temp & eChgErr_CpErr)
      AlarmSaveToLog(0x01, eChgErr_CpErr);//ϵͳ澯 0x01
//    if(Temp & eChgErr_ConnectErr)
//      AlarmSaveToLog(0x01, eChgErr_ConnectErr);//ϵͳ澯 0x01
    if(Temp & eChgErr_CurrtLeak)
      AlarmSaveToLog(0x01, eChgErr_CurrtLeak);//ϵͳ澯 0x01
    if(Temp & eChgErr_CurrtOver)
      AlarmSaveToLog(0x01, eChgErr_CurrtOver);//ϵͳ澯 0x01
    if(Temp & eChgErr_CurrtProt)
      AlarmSaveToLog(0x01, eChgErr_CurrtProt);//ϵͳ澯 0x01
    if(Temp & eChgErr_VoltHigh)
      AlarmSaveToLog(0x01, eChgErr_VoltHigh);//ϵͳ澯 0x01
    if(Temp & eChgErr_VoltLow)
      AlarmSaveToLog(0x01, eChgErr_VoltLow);//ϵͳ澯 0x01

    if(Temp & eChgErr_TempOver)
      AlarmSaveToLog(0x01, eChgErr_TempOver);//ϵͳ澯 0x01
    if(Temp & eChgErr_NoneGnd)
      AlarmSaveToLog(0x01, eChgErr_NoneGnd);//ϵͳ澯 0x01
    if(Temp & eChgErr_PhaseErr)
      AlarmSaveToLog(0x01, eChgErr_PhaseErr);//ϵͳ澯 0x01
    if(Temp & eChgErr_Reader)
      AlarmSaveToLog(0x01, eChgErr_Reader);//ϵͳ澯 0x01
    if(Temp & eChgErr_Meter)
      AlarmSaveToLog(0x01, eChgErr_Meter);//ϵͳ澯 0x01
    if(Temp & eChgErr_Memory)
      AlarmSaveToLog(0x01, eChgErr_Memory);//ϵͳ澯 0x01
    if(Temp & eChgErr_Display)
      AlarmSaveToLog(0x01, eChgErr_Display);//ϵͳ澯 0x01
    if(Temp & eChgErr_NetConnect)
      AlarmSaveToLog(0x01, eChgErr_NetConnect);//ϵͳ澯 0x01
  }
  LastChargeErr = ChargeError;
#endif
}

osMessageQId EventSaveMsg = NULL;

void SaveEventDone(void)
{
//  osEvent Even;

//  Even = osMessageGet(EventSaveMsg, 0);
//  if(osEventMessage == Even.status)
//    EventSaveToLog(Even.value.v);
}

#if 0
void TimeSynWithExtRtc(void)
{
  StructTime Time;

  if(TRUE == RtcExtGetTime(&Time))
    DateTimeSet(TimeToStamp(&Time));
}
#endif

void Reset_Handler(void);

/******************************************************************************
  : Thread_Internet
  : ܱȡ߳
  : argument - ̴߳
  : 
******************************************************************************/
//void Thread_Internet(void const *argument)
void Internet(void const *argument)
{
//  u32 TimeSynTime;

  InternetInit();

  CommuStatus.ConnectFlag = 0;

  TempRecdSave();

//  TimeSynTime = RTC_GetCounter();

  for(;;)
  {
#if 0
    if((RTC_GetCounter() - TimeSynTime) > 3600)
    {
      TimeSynWithExtRtc();
      TimeSynTime = RTC_GetCounter();
    }

    if(IpSetDelay.SetFlag)
    {
      if(RTC_GetCounter() >= IpSetDelay.SetTime)
      {
        ServerAddr = IpSetDelay.IpAddr;
        SaveMemory(eeAddr_ServerAddr, (u8*)&ServerAddr, sizeof(ServerAddr));
        memset(&IpSetDelay, 0, sizeof(IpSetDelay));
        SaveMemory(eeAddr_IpSetDelay, (u8*)&IpSetDelay, sizeof(IpSetDelay));
        ResetFlag = 1;
      }
    }
#endif

    NetRecvProcess();//֡
    NetWorkProcess();//ݸ
    NetLinkProcess();//,ǩ

    AlarmCodeDone();//澯ϴ
    SaveEventDone();

    if(0 != ResetFlag)
    {
      if(0 == CurChgRecd.RecordValid && 0 == CurChgRecd_B.RecordValid)//ûгڳ
      {
        SendPillarSignOut();
        osDelay(500);
        osDelay(500);
        osDelay(500);
        NVIC_SystemReset();//GT
      //  Reset_Handler();
      }
    }

    osDelay(100);
  }
}

osThreadId InternetHandle;





