/**
  ******************************************************************************
  * File Name          : main.c
  * Date               : 16/08/2014 15:04:19
  * Description        : Main program body
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "Thd_Charge.h"

#include "Drv_WatchDog.h"


/* Private variables ---------------------------------------------------------*/


/* Private function prototypes -----------------------------------------------*/
void vApplicationStackOverflowHook( TaskHandle_t xTask, char *pcTaskName )
{
}




void vApplicationIdleHook( void )
{
  FeedDog();
}

//#pragma section = ".checksum"

//extern u16 __checksum;
//__root const u32 __aa__ = (u32)&__checksum;


/*
void* EndProgam;



#pragma section = "ProgramStart"

#pragma location="ProgramStart"

EndProgam = __section_begin(".checksum");//CheckSun$$Base)//
EndProgam = __section_end(".checksum");
EndProgam = &__checksum;
EndProgam = __section_begin("ProgramStart");//CheckSun$$Base)//
EndProgam = __section_end("ProgramStart");
EndProgam = (void*)&__aa__;
*/

extern void Thd_Mult(void const *parameter);
extern void Thd_Charge(void const *parameter);
extern void Thd_Charge_B(void const *parameter);
extern void Thd_Lcd(void const *parameter);
//extern void Internet(void const *argument);
extern void TCUComm(void const *argument);
void Thd_TCUControl(void const *parameter);





int main(void)
{
  /* USER CODE BEGIN 1 */
  /* USER CODE END 1 */

//  RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);
//  GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable, ENABLE);      /*ʹSWD JTAG*/

  /* MCU Configuration----------------------------------------------------------*/
  SystemInit();

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
//  HAL_Init();

  /* Configure the system clock */
//  SystemClock_Config();

  /* System interrupt init*/
  /* Sets the priority grouping field */
//  HAL_NVIC_SetPriorityGrouping(NVIC_PRIORITYGROUP_4);
//  HAL_NVIC_SetPriority(SysTick_IRQn, 0, 0);
  /* NVIC configuration */
  /* Configure the Priority Group to 2 bits */
  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_4);


  /* Initialize all configured peripherals */
//  MX_GPIO_Init();
//  MX_CAN1_Init();
//  MX_CAN2_Init();
  //MX_ETH_Init();
//  MX_SPI1_Init();
//  MX_SPI2_Init();
//  MX_UART4_Init();
//  MX_UART5_Init();
//  MX_USART1_UART_Init();
//  MX_USART2_UART_Init();
//  MX_USART3_UART_Init();
//  MX_USART6_UART_Init();
//  MX_USB_OTG_FS_PCD_Init();


  /* USER CODE BEGIN 2 */
  SystemCoreClockUpdate();
  SysTick_Config(SystemCoreClock/1000);
//    NVIC_EnableIRQ(SysTick_IRQn);
  /* USER CODE END 2 */

  /* Code generated for FreeRTOS */
  /* Create Start thread */
  {
  osThreadDef(Thd_Charge, Thd_Charge, osPriorityHigh, 0, 2*configMINIMAL_STACK_SIZE);
  osThreadCreate(osThread(Thd_Charge), NULL);

  osThreadDef(Thd_Charge_B, Thd_Charge_B, osPriorityHigh, 0, 2*configMINIMAL_STACK_SIZE);
  osThreadCreate(osThread(Thd_Charge_B), NULL);

  osThreadDef(Thd_Mult, Thd_Mult, osPriorityNormal, 0, configMINIMAL_STACK_SIZE);
  osThreadCreate(osThread(Thd_Mult), NULL);

  osThreadDef(Thd_Lcd, Thd_Lcd, osPriorityNormal, 0, 2*configMINIMAL_STACK_SIZE);
  osThreadCreate(osThread(Thd_Lcd), NULL);
  osThreadDef(Thd_TCUControl, Thd_TCUControl, osPriorityNormal, 0, 2*configMINIMAL_STACK_SIZE);
  osThreadCreate(osThread(Thd_TCUControl), NULL);
  //osThreadDef(Internet, Internet, osPriorityNormal, 0, 2*configMINIMAL_STACK_SIZE);
  //osThreadCreate(osThread(Internet), NULL);
  osThreadDef(TCUComm, TCUComm, osPriorityNormal, 0, 2*configMINIMAL_STACK_SIZE);
  osThreadCreate(osThread(TCUComm), NULL);
  
  
  }
  DBGMCU_Config(DBGMCU_IWDG_STOP, ENABLE);

  //WdgInit();

  /* Start scheduler */
  osKernelStart();

  /* We should never get here as control is now taken by the scheduler */

  /* USER CODE BEGIN 3 */
  /* Infinite loop */
  while (1)
  {

  }
  /* USER CODE END 3 */
}

